local ElvUI_EltreumUI, E, L, V, P, G = unpack(select(2, ...))
local classcolor = E:ClassColor(E.myclass, true)
local _G = _G
local IsAddOnLoaded = _G.IsAddOnLoaded
local C_CVar = _G.C_CVar

function ElvUI_EltreumUI:SetupLayoutHealer()
	if E.Retail then
		E.db["unitframe"]["units"]["player"]["customTexts"] = E.db["unitframe"]["units"]["player"]["customTexts"] or {}
		E.db["unitframe"]["units"]["player"]["customTexts"]["EltreumPlayerAbsorb"] = {
		["enable"] = true
		}
		E.db["unitframe"]["units"]["party"]["customTexts"] = E.db["unitframe"]["units"]["party"]["customTexts"] or {}
		E.db["unitframe"]["units"]["party"]["customTexts"]["EltreumPartyAbsorb"] = {
		["enable"] = true
		}
		E.db["unitframe"]["units"]["raid"]["customTexts"] = E.db["unitframe"]["units"]["raid"]["customTexts"] or {}
		E.db["unitframe"]["units"]["raid"]["customTexts"]["EltreumRaidAbsorb"] = {
		["enable"] = true
		}
		E.db["unitframe"]["units"]["raid40"]["customTexts"] = E.db["unitframe"]["units"]["raid40"]["customTexts"] or {}
		E.db["unitframe"]["units"]["raid40"]["customTexts"]["EltreumRaid40Absorb"] = {
		["enable"] = true
		}
		E.db["unitframe"]["units"]["target"]["customTexts"] = E.db["unitframe"]["units"]["target"]["customTexts"] or {}
		E.db["unitframe"]["units"]["target"]["customTexts"]["EltreumTargetAbsorb"] = {
		["enable"] = true
		}
	end

	--healprediction
	E.db["unitframe"]["units"]["target"]["healPrediction"]["enable"] = true
	E.db["unitframe"]["units"]["player"]["healPrediction"]["enable"] = true
	E.db["unitframe"]["units"]["party"]["healPrediction"]["enable"] = true
	E.db["unitframe"]["units"]["raid"]["healPrediction"]["enable"] = true
	E.db["unitframe"]["units"]["raidpet"]["healPrediction"]["enable"] = true
	E.db["unitframe"]["units"]["raid40"]["healPrediction"]["enable"] = true
	E.db["unitframe"]["units"]["tank"]["healPrediction"]["enable"] = true

	--aura indicator
	E.db["unitframe"]["units"]["party"]["buffIndicator"]["enable"] = true
	E.db["unitframe"]["units"]["raid"]["buffIndicator"]["enable"] = true
	E.db["unitframe"]["units"]["raid40"]["buffIndicator"]["enable"] = true
	E.db["unitframe"]["units"]["tank"]["buffIndicator"]["enable"] = true

	--set Dynamic Status Icons
	if IsAddOnLoaded("ElvUI_DynamicStatusIcons") then
		E.db["unitframe"]["units"]["player"]["DynamicStatusIcons"]["anchorPoint"] = "BOTTOMRIGHT"
		E.db["unitframe"]["units"]["player"]["DynamicStatusIcons"]["color"]["b"] = 0.4274500310421
		E.db["unitframe"]["units"]["player"]["DynamicStatusIcons"]["color"]["g"] = 0.60784178972244
		E.db["unitframe"]["units"]["player"]["DynamicStatusIcons"]["color"]["r"] = 0.77646887302399
		E.db["unitframe"]["units"]["player"]["DynamicStatusIcons"]["faceright"] = true
		E.db["unitframe"]["units"]["player"]["DynamicStatusIcons"]["iconpack"] = "Default - Pepe - Traveler"
		E.db["unitframe"]["units"]["player"]["DynamicStatusIcons"]["scale"] = 0.8
		E.db["unitframe"]["units"]["player"]["DynamicStatusIcons"]["xOffset"] = -49
		E.db["unitframe"]["units"]["player"]["DynamicStatusIcons"]["yOffset"] = -88
		E.db["unitframe"]["units"]["target"]["DynamicStatusIcons"]["anchorPoint"] = "BOTTOMLEFT"
		E.db["unitframe"]["units"]["target"]["DynamicStatusIcons"]["color"]["b"] = 0.4274500310421
		E.db["unitframe"]["units"]["target"]["DynamicStatusIcons"]["color"]["g"] = 0.60784178972244
		E.db["unitframe"]["units"]["target"]["DynamicStatusIcons"]["color"]["r"] = 0.77646887302399
		E.db["unitframe"]["units"]["target"]["DynamicStatusIcons"]["iconpack"] = "Default - Pepe - Clockwork"
		E.db["unitframe"]["units"]["target"]["DynamicStatusIcons"]["scale"] = 0.8
		E.db["unitframe"]["units"]["target"]["DynamicStatusIcons"]["xOffset"] = 49
		E.db["unitframe"]["units"]["target"]["DynamicStatusIcons"]["yOffset"] = -88
	end
	-- Healer Action bars
	E.db["actionbar"]["addNewSpells"] = true
	E.db["actionbar"]["bar1"]["buttonSize"] = 40
	E.db["actionbar"]["bar1"]["buttonSpacing"] = 3
	E.db["actionbar"]["bar1"]["buttons"] = 7
	E.db["actionbar"]["bar1"]["countFont"] = "Kimberley"
	E.db["actionbar"]["bar1"]["hotkeyFont"] = "Kimberley"
	E.db["actionbar"]["bar1"]["keepSizeRatio"] = false
	E.db["actionbar"]["bar1"]["macroFont"] = "Kimberley"
	E.db["actionbar"]["bar1"]["paging"]["DEATHKNIGHT"] = ""
	E.db["actionbar"]["bar1"]["paging"]["DEMONHUNTER"] = ""
	E.db["actionbar"]["bar1"]["paging"]["DRUID"] = ""
	E.db["actionbar"]["bar1"]["paging"]["HUNTER"] = ""
	E.db["actionbar"]["bar1"]["paging"]["MAGE"] = ""
	E.db["actionbar"]["bar1"]["paging"]["MONK"] = ""
	E.db["actionbar"]["bar1"]["paging"]["PALADIN"] = ""
	E.db["actionbar"]["bar1"]["paging"]["PRIEST"] = ""
	E.db["actionbar"]["bar1"]["paging"]["ROGUE"] = ""
	E.db["actionbar"]["bar1"]["paging"]["SHAMAN"] = ""
	E.db["actionbar"]["bar1"]["paging"]["WARLOCK"] = ""
	E.db["actionbar"]["bar1"]["paging"]["WARRIOR"] = ""
	E.db["actionbar"]["bar1"]["point"] = "TOPLEFT"
	E.db["actionbar"]["bar1"]["visibility"] = "[vehicleui] hide; [overridebar] hide; [possessbar] hide; [petbattle] hide; show"
	E.db["actionbar"]["bar10"]["countFont"] = "Kimberley"
	E.db["actionbar"]["bar10"]["hotkeyFont"] = "Kimberley"
	E.db["actionbar"]["bar10"]["macroFont"] = "Kimberley"
	E.db["actionbar"]["bar10"]["point"] = "TOPLEFT"
	E.db["actionbar"]["bar10"]["visibility"] = "[vehicleui] hide; [overridebar] hide; [possessbar] hide; [petbattle] hide; show"
	E.db["actionbar"]["bar10"]["enabled"] = false
	E.db["actionbar"]["bar2"]["buttonHeight"] = 25
	E.db["actionbar"]["bar2"]["buttonSize"] = 30
	E.db["actionbar"]["bar2"]["buttonSpacing"] = 3
	E.db["actionbar"]["bar2"]["buttons"] = 12
	E.db["actionbar"]["bar2"]["countFont"] = "Kimberley"
	E.db["actionbar"]["bar2"]["enabled"] = true
	E.db["actionbar"]["bar2"]["hotkeyFont"] = "Kimberley"
	E.db["actionbar"]["bar2"]["keepSizeRatio"] = false
	E.db["actionbar"]["bar2"]["macroFont"] = "Kimberley"
	E.db["actionbar"]["bar2"]["point"] = "TOPLEFT"
	E.db["actionbar"]["bar2"]["visibility"] = "[vehicleui] hide; [overridebar] hide; [possessbar] hide; [petbattle] hide; show"
	E.db["actionbar"]["bar3"]["buttonsPerRow"] = 6
	E.db["actionbar"]["bar3"]["buttonHeight"] = 25
	E.db["actionbar"]["bar3"]["buttonSize"] = 30
	E.db["actionbar"]["bar3"]["buttonSpacing"] = 3
	E.db["actionbar"]["bar3"]["buttons"] = 12
	E.db["actionbar"]["bar3"]["countFont"] = "Kimberley"
	E.db["actionbar"]["bar3"]["hotkeyFont"] = "Kimberley"
	E.db["actionbar"]["bar3"]["keepSizeRatio"] = false
	E.db["actionbar"]["bar3"]["macroFont"] = "Kimberley"
	E.db["actionbar"]["bar3"]["point"] = "TOPLEFT"
	E.db["actionbar"]["bar3"]["visibility"] = "[vehicleui] hide; [overridebar] hide; [possessbar] hide; [petbattle] hide; show"
	E.db["actionbar"]["bar3"]["mouseover"] = false
	E.db["actionbar"]["bar4"]["mouseover"] = false
	E.db["actionbar"]["bar4"]["backdrop"] = false
	E.db["actionbar"]["bar4"]["buttonHeight"] = 25
	E.db["actionbar"]["bar4"]["buttonSize"] = 30
	E.db["actionbar"]["bar4"]["buttonSpacing"] = 3
	E.db["actionbar"]["bar4"]["buttonsPerRow"] = 12
	E.db["actionbar"]["bar4"]["buttons"] = 12
	E.db["actionbar"]["bar4"]["countFont"] = "Kimberley"
	E.db["actionbar"]["bar4"]["hotkeyFont"] = "Kimberley"
	E.db["actionbar"]["bar4"]["keepSizeRatio"] = false
	E.db["actionbar"]["bar4"]["macroFont"] = "Kimberley"
	E.db["actionbar"]["bar4"]["paging"]["DEATHKNIGHT"] = "[vehicleui] 12; [overridebar] 14;[possessbar] 12;"
	E.db["actionbar"]["bar4"]["paging"]["DEMONHUNTER"] = "[vehicleui] 12; [overridebar] 14;[possessbar] 12;"
	E.db["actionbar"]["bar4"]["paging"]["DRUID"] = "[vehicleui] 12; [overridebar] 14; [possessbar] 12; [bonusbar:1,nostealth] 7; [bonusbar:1,stealth] 8; [bonusbar:2] 8; [bonusbar:3] 9; [bonusbar:4] 10;"
	--E.db["actionbar"]["bar4"]["paging"]["DRUID"] = "[bonusbar:1,nostealth] 7; [bonusbar:1,stealth] 8; [bonusbar:2] 8; [bonusbar:3] 9; [bonusbar:4] 10; [vehicleui] 12; [overridebar] 14; [possessbar] 12;" --had issues with some WQs
	E.db["actionbar"]["bar4"]["paging"]["HUNTER"] = "[vehicleui] 12; [overridebar] 14;[possessbar] 12;"
	E.db["actionbar"]["bar4"]["paging"]["MAGE"] = "[vehicleui] 12; [overridebar] 14;[possessbar] 12;"
	E.db["actionbar"]["bar4"]["paging"]["MONK"] = "[vehicleui] 12; [overridebar] 14; [possessbar] 12;"
	E.db["actionbar"]["bar4"]["paging"]["PALADIN"] = "[vehicleui] 12; [overridebar] 14; [possessbar] 12;"
	E.db["actionbar"]["bar4"]["paging"]["PRIEST"] = "[vehicleui] 12; [overridebar] 14; [possessbar] 12;"
	E.db["actionbar"]["bar4"]["paging"]["ROGUE"] = "[bonusbar:1] 7;[bonusbar:1,nostealth] 4; [bonusbar:1,stealth] 7; [vehicleui] 12; [overridebar] 14; [possessbar] 12;[bonusbar:2] 8;" --other other besides this was causing problems with shadow dance
	--E.db["actionbar"]["bar4"]["paging"]["ROGUE"] = "[bonusbar:1] 7;[bonusbar:1,nostealth] 1; [bonusbar:1,stealth] 7; [vehicleui] 12; [overridebar] 14; [possessbar] 12;" --other other besides this was causing problems with shadow dance
	E.db["actionbar"]["bar4"]["paging"]["SHAMAN"] = "[vehicleui] 12; [overridebar] 14; [possessbar] 12;"
	E.db["actionbar"]["bar4"]["paging"]["WARLOCK"] = "[vehicleui] 12; [overridebar] 14;[possessbar] 12;[form:1] 7;"
	E.db["actionbar"]["bar4"]["paging"]["WARRIOR"] = "[vehicleui] 12; [overridebar] 14;[possessbar] 12;"
	E.db["actionbar"]["bar4"]["point"] = "TOPLEFT"
	E.db["actionbar"]["bar4"]["visibility"] = "[vehicleui] show; [overridebar] show; [possessbar] show; [petbattle] hide; show;"
	E.db["actionbar"]["bar5"]["buttonsPerRow"] = 6
	E.db["actionbar"]["bar5"]["buttonHeight"] = 25
	E.db["actionbar"]["bar5"]["buttonSize"] = 30
	E.db["actionbar"]["bar5"]["buttonSpacing"] = 3
	E.db["actionbar"]["bar5"]["buttons"] = 12
	E.db["actionbar"]["bar5"]["countFont"] = "Kimberley"
	E.db["actionbar"]["bar5"]["hotkeyFont"] = "Kimberley"
	E.db["actionbar"]["bar5"]["keepSizeRatio"] = false
	E.db["actionbar"]["bar5"]["enabled"] = true
	E.db["actionbar"]["bar5"]["macroFont"] = "Kimberley"
	E.db["actionbar"]["bar5"]["point"] = "TOPLEFT"
	E.db["actionbar"]["bar5"]["visibility"] = "[vehicleui] hide; [overridebar] hide; [possessbar] hide; [petbattle] hide; show"
	E.db["actionbar"]["bar6"]["alpha"] = 1
	E.db["actionbar"]["bar6"]["buttonHeight"] = 24
	if C_CVar.GetCVar('gxFullscreenResolution') == "3840x2160" or C_CVar.GetCVar('gxWindowedResolution') == "3840x2160" then
		E.db["actionbar"]["bar6"]["buttonSpacing"] = 0
		E.db["actionbar"]["bar6"]["buttonSize"] = 35
	elseif C_CVar.GetCVar('gxFullscreenResolution') == "2560x1440" or C_CVar.GetCVar('gxWindowedResolution') == "2560x1440" then
		E.db["actionbar"]["bar6"]["buttonSpacing"] = 1
		E.db["actionbar"]["bar6"]["buttonSize"] = 33
	elseif C_CVar.GetCVar('gxFullscreenResolution') == "1920x1080" or C_CVar.GetCVar('gxWindowedResolution') == "1920x1080" then
		E.db["actionbar"]["bar6"]["buttonSpacing"] = 1
		E.db["actionbar"]["bar6"]["buttonSize"] = 33
	elseif C_CVar.GetCVar('gxFullscreenResolution') == "auto" or C_CVar.GetCVar('gxWindowedResolution') == "auto" then
		E.db["actionbar"]["bar6"]["buttonSpacing"] = 1
		E.db["actionbar"]["bar6"]["buttonSize"] = 33
	else
		E.db["actionbar"]["bar6"]["buttonSpacing"] = 1
		E.db["actionbar"]["bar6"]["buttonSize"] = 33
	end
	E.db["actionbar"]["bar6"]["buttons"] = 12
	E.db["actionbar"]["bar6"]["buttonsPerRow"] = 12
	E.db["actionbar"]["bar6"]["countFont"] = "Kimberley"
	E.db["actionbar"]["bar6"]["countFontOutline"] = "THICKOUTLINE"
	E.db["actionbar"]["bar6"]["enabled"] = true
	E.db["actionbar"]["bar6"]["flyoutDirection"] = "UP"
	E.db["actionbar"]["bar6"]["hotkeyFont"] = "Kimberley"
	E.db["actionbar"]["bar6"]["hotkeyFontOutline"] = "THICKOUTLINE"
	E.db["actionbar"]["bar6"]["keepSizeRatio"] = false
	E.db["actionbar"]["bar6"]["macroFont"] = "Kimberley"
	E.db["actionbar"]["bar6"]["macroFontOutline"] = "THICKOUTLINE"
	E.db["actionbar"]["bar6"]["macroTextPosition"] = "BOTTOM"
	E.db["actionbar"]["bar6"]["macroTextYOffset"] = 2
	E.db["actionbar"]["bar6"]["macrotext"] = true
	E.db["actionbar"]["bar6"]["mouseover"] = true
	E.db["actionbar"]["bar7"]["countFont"] = "Kimberley"
	E.db["actionbar"]["bar7"]["hotkeyFont"] = "Kimberley"
	E.db["actionbar"]["bar7"]["macroFont"] = "Kimberley"
	E.db["actionbar"]["bar7"]["point"] = "TOPLEFT"
	E.db["actionbar"]["bar7"]["visibility"] = "[vehicleui] hide; [overridebar] hide; [possessbar] hide; [petbattle] hide; show"
	E.db["actionbar"]["bar7"]["enabled"] = false
	E.db["actionbar"]["bar8"]["countFont"] = "Kimberley"
	E.db["actionbar"]["bar8"]["hotkeyFont"] = "Kimberley"
	E.db["actionbar"]["bar8"]["macroFont"] = "Kimberley"
	E.db["actionbar"]["bar8"]["point"] = "TOPLEFT"
	E.db["actionbar"]["bar8"]["visibility"] = "[vehicleui] hide; [overridebar] hide; [possessbar] hide; [petbattle] hide; show"
	E.db["actionbar"]["bar8"]["enabled"] = false
	E.db["actionbar"]["bar9"]["countFont"] = "Kimberley"
	E.db["actionbar"]["bar9"]["hotkeyFont"] = "Kimberley"
	E.db["actionbar"]["bar9"]["macroFont"] = "Kimberley"
	E.db["actionbar"]["bar9"]["point"] = "TOPLEFT"
	E.db["actionbar"]["bar9"]["visibility"] = "[vehicleui] hide; [overridebar] hide; [possessbar] hide; [petbattle] hide; show"
	E.db["actionbar"]["bar9"]["enabled"] = false
	E.db["actionbar"]["barPet"]["buttonHeight"] = 18
	E.db["actionbar"]["barPet"]["buttonSize"] = 31
	E.db["actionbar"]["barPet"]["buttonsPerRow"] = 3
	E.db["actionbar"]["barPet"]["countFont"] = "Kimberley"
	E.db["actionbar"]["barPet"]["hotkeyFont"] = "Kimberley"
	E.db["actionbar"]["barPet"]["keepSizeRatio"] = false
	E.db["actionbar"]["barPet"]["point"] = "TOPLEFT"
	E.db["actionbar"]["chargeCooldown"] = true
	E.db["actionbar"]["desaturateOnCooldown"] = true
	E.db["actionbar"]["extraActionButton"]["alpha"] = 0.7
	E.db["actionbar"]["extraActionButton"]["clean"] = true
	E.db["actionbar"]["extraActionButton"]["hotkeyFont"] = "Kimberley"
	E.db["actionbar"]["extraActionButton"]["hotkeyFontOutline"] = "THICKOUTLINE"
	E.db["actionbar"]["extraActionButton"]["scale"] = 0.7
	E.db["actionbar"]["font"] = "Kimberley"
	E.db["actionbar"]["globalFadeAlpha"] = 1
	E.db["actionbar"]["lockActionBars"] = false
	E.db["actionbar"]["noPowerColor"]["b"] = 0.43921568627451
	E.db["actionbar"]["noPowerColor"]["g"] = 0.21960784313725
	E.db["actionbar"]["noPowerColor"]["r"] = 0.21960784313725
	E.db["actionbar"]["notUsableColor"]["b"] = 0.16862745098039
	E.db["actionbar"]["notUsableColor"]["g"] = 0.16862745098039
	E.db["actionbar"]["notUsableColor"]["r"] = 0.16862745098039
	E.db["actionbar"]["rightClickSelfCast"] = true
	E.db["actionbar"]["stanceBar"]["style"] = "classic"
	E.db["actionbar"]["stanceBar"]["keepSizeRatio"] = false
	E.db["actionbar"]["stanceBar"]["buttonSize"] = 27
	E.db["actionbar"]["stanceBar"]["buttonHeight"] = 20
	E.db["actionbar"]["stanceBar"]["buttonSpacing"] = 3
	E.db["actionbar"]["stanceBar"]["hotkeyFont"] = "Kimberley"
	E.db["actionbar"]["stanceBar"]["hotkeyFontOutline"] = "THICKOUTLINE"
	E.db["actionbar"]["stanceBar"]["inheritGlobalFade"] = true
	if E.Retail then
		E.db["actionbar"]["stanceBar"]["mouseover"] = true
	elseif E.Wrath or E.TBC or E.Classic then
		E.db["actionbar"]["stanceBar"]["mouseover"] = false
	end
	E.db["actionbar"]["stanceBar"]["visibility"] = "[vehicleui] hide; [overridebar] hide; [possessbar] hide; [petbattle] hide; show"
	E.db["actionbar"]["transparent"] = true
	E.db["actionbar"]["useDrawSwipeOnCharges"] = true
	E.db["actionbar"]["vehicleExitButton"]["hotkeyFont"] = "Kimberley"
	E.db["actionbar"]["zoneActionButton"]["alpha"] = 0.7
	E.db["actionbar"]["zoneActionButton"]["clean"] = true
	E.db["actionbar"]["zoneActionButton"]["scale"] = 0.7
	E.db["actionbar"]["microbar"]["backdrop"] = true
	E.db["actionbar"]["microbar"]["buttonHeight"] = 25
	E.db["actionbar"]["microbar"]["buttonSize"] = 22
	E.db["actionbar"]["microbar"]["buttonSpacing"] = 0
	E.db["actionbar"]["microbar"]["buttonsPerRow"] = 11
	E.db["actionbar"]["microbar"]["enabled"] = true
	E.db["actionbar"]["microbar"]["visibility"] = "[combat] hide; show"
	E.db["actionbar"]["microbar"]["mouseover"] = true

	-- Healer Auras
	E.db["auras"]["buffs"]["barColor"]["b"] = 0.86666476726532
	E.db["auras"]["buffs"]["barColor"]["g"] = 0.4392147064209
	E.db["auras"]["buffs"]["barNoDuration"] = false
	E.db["auras"]["buffs"]["barPosition"] = "LEFT"
	E.db["auras"]["buffs"]["barShow"] = false
	E.db["auras"]["buffs"]["barSize"] = 6
	E.db["auras"]["buffs"]["barSpacing"] = 0
	E.db["auras"]["buffs"]["barTexture"] = "Eltreum-Blank"
	E.db["auras"]["buffs"]["countFont"] = "Kimberley"
	E.db["auras"]["buffs"]["countFontOutline"] = "THICKOUTLINE"
	E.db["auras"]["buffs"]["countFontSize"] = 12
	E.db["auras"]["buffs"]["fadeThreshold"] = 10
	E.db["auras"]["buffs"]["horizontalSpacing"] = 7
	E.db["auras"]["buffs"]["maxWraps"] = 2
	E.db["auras"]["buffs"]["size"] = 32
	E.db["auras"]["buffs"]["sortDir"] = "+"
	E.db["auras"]["buffs"]["timeFont"] = "Kimberley"
	E.db["auras"]["buffs"]["timeFontOutline"] = "THICKOUTLINE"
	E.db["auras"]["buffs"]["timeFontSize"] = 12
	E.db["auras"]["buffs"]["verticalSpacing"] = 14
	E.db["auras"]["buffs"]["wrapAfter"] = 10
	E.db["auras"]["debuffs"]["barColor"]["b"] = 0.86666476726532
	E.db["auras"]["debuffs"]["barColor"]["g"] = 0.4392147064209
	E.db["auras"]["debuffs"]["barNoDuration"] = false
	E.db["auras"]["debuffs"]["barPosition"] = "LEFT"
	E.db["auras"]["debuffs"]["barShow"] = false
	E.db["auras"]["debuffs"]["barSize"] = 6
	E.db["auras"]["debuffs"]["barSpacing"] = 0
	E.db["auras"]["debuffs"]["barTexture"] = "Eltreum-Blank"
	E.db["auras"]["debuffs"]["countFont"] = "Kimberley"
	E.db["auras"]["debuffs"]["countFontOutline"] = "THICKOUTLINE"
	E.db["auras"]["debuffs"]["countFontSize"] = 12
	E.db["auras"]["debuffs"]["fadeThreshold"] = 5
	E.db["auras"]["debuffs"]["horizontalSpacing"] = 7
	E.db["auras"]["debuffs"]["size"] = 32
	E.db["auras"]["debuffs"]["sortDir"] = "+"
	E.db["auras"]["debuffs"]["timeFont"] = "Kimberley"
	E.db["auras"]["debuffs"]["timeFontOutline"] = "THICKOUTLINE"
	E.db["auras"]["debuffs"]["timeFontSize"] = 12
	E.db["auras"]["debuffs"]["verticalSpacing"] = 14
	E.db["auras"]["debuffs"]["wrapAfter"] = 10
	-- Growth Directions Healing
	E.db["unitframe"]["units"]["party"]["growthDirection"] = "RIGHT_UP"
	E.db["unitframe"]["units"]["raid"]["growthDirection"] = "DOWN_RIGHT"
	E.db["unitframe"]["units"]["raid40"]["growthDirection"] = "DOWN_RIGHT"
	-- Movers Healing
	--E.db["movers"]["ArenaHeaderMover"] = "TOPRIGHT,UIParent,TOPRIGHT,-92,-293"
	E.db["movers"]["ArenaHeaderMover"] = "TOPRIGHT,UIParent,TOPRIGHT,-65,-292"
	E.db["movers"]["AzeriteBarMover"] = "BOTTOMRIGHT,ElvUIParent,BOTTOMRIGHT,-421,0"
	E.db["movers"]["BNETMover"] = "TOPRIGHT,ElvUIParent,TOPRIGHT,-6,-259"
	E.db["movers"]["BelowMinimapContainerMover"] = "TOPLEFT,ElvUIParent,TOPLEFT,79,-155"
	E.db["movers"]["BigButtonsFarmBar"] = "TOPLEFT,ElvUIParent,TOPLEFT,433,-134"
	E.db["movers"]["BigButtonsSeedBarMover"] = "TOPLEFT,ElvUIParent,TOPLEFT,281,-186"
	E.db["movers"]["BossButton"] = "BOTTOMRIGHT,ElvUIParent,BOTTOMRIGHT,-458,126"
	--E.db["movers"]["BossHeaderMover"] = "TOPRIGHT,ElvUIParent,TOPRIGHT,-27,-384"
	E.db["movers"]["BossHeaderMover"] = "TOPRIGHT,UIParent,TOPRIGHT,-4,-334"
	E.db["movers"]["BuffsMover"] = "TOPRIGHT,ElvUIParent,TOPRIGHT,-213,-4"
	E.db["movers"]["DebuffsMover"] = "TOPRIGHT,ElvUIParent,TOPRIGHT,-213,-101"
	E.db["movers"]["DurabilityFrameMover"] = "BOTTOMLEFT,ElvUIParent,BOTTOMLEFT,498,366"
	E.db["movers"]["ElvAB_1"] = "BOTTOM,ElvUIParent,BOTTOM,0,307"
	E.db["movers"]["ElvAB_10"] = "BOTTOMRIGHT,ElvUIParent,BOTTOMRIGHT,-4,344"
	E.db["movers"]["ElvAB_2"] = "BOTTOM,ElvUIParent,BOTTOM,0,280"
	E.db["movers"]["ElvAB_3"] = "BOTTOM,ElvUIParent,BOTTOM,308,253"
	E.db["movers"]["ElvAB_4"] = "BOTTOM,ElvUIParent,BOTTOM,0,253"
	E.db["movers"]["ElvAB_5"] = "BOTTOM,ElvUIParent,BOTTOM,-308,253"
	E.db["movers"]["ElvAB_6"] = "BOTTOMRIGHT,ElvUIParent,BOTTOMRIGHT,0,205"
	E.db["movers"]["ElvAB_7"] = "BOTTOMRIGHT,ElvUIParent,BOTTOMRIGHT,-4,240"
	E.db["movers"]["ElvAB_8"] = "BOTTOMRIGHT,ElvUIParent,BOTTOMRIGHT,-4,275"
	E.db["movers"]["ElvAB_9"] = "BOTTOMRIGHT,ElvUIParent,BOTTOMRIGHT,-4,310"
	E.db["movers"]["ElvUF_AssistMover"] = "TOPLEFT,ElvUIParent,TOPLEFT,438,-522"
	E.db["movers"]["ElvUF_FocusMover"] = "TOPLEFT,ElvUIParent,TOPLEFT,424,-204"
	E.db["movers"]["ElvUF_FocusCastbarMover"] = "TOP,ElvUIParent,TOP,0,-168"
	E.db["movers"]["ElvUF_PartyMover"] = "BOTTOM,ElvUIParent,BOTTOM,0,87"
	E.db["movers"]["ElvUF_PetCastbarMover"] = "BOTTOMLEFT,ElvUIParent,BOTTOMLEFT,311,352"
	E.db["movers"]["ElvUF_PetMover"] = "BOTTOMLEFT,ElvUIParent,BOTTOMLEFT,426,336"
	E.db["movers"]["ElvUF_PlayerCastbarMover"] = "BOTTOM,ElvUIParent,BOTTOM,14,355"
	E.db["movers"]["PlayerPowerBarMover"] = "BOTTOM,ElvUIParent,BOTTOM,1,340"
	E.db["movers"]["ElvUF_PlayerMover"] = "BOTTOM,ElvUIParent,BOTTOM,-280,387"
	E.db["movers"]["ElvUF_Raid40Mover"] = "BOTTOM,ElvUIParent,BOTTOM,0,-1"
	E.db["movers"]["ElvUF_RaidMover"] = "BOTTOM,ElvUIParent,BOTTOM,0,-1"
	--E.db["movers"]["ElvUF_RaidpetMover"] = "BOTTOMLEFT,ElvUIParent,BOTTOMLEFT,0,204" --healer pet mover
	E.db["movers"]["ElvUF_RaidpetMover"] = "BOTTOMLEFT,UIParent,BOTTOMLEFT,4,217" --new
	--E.db["movers"]["ElvUF_TankMover"] = "TOPRIGHT,UIParent,TOPRIGHT,-427,-515"
	E.db["movers"]["ElvUF_TankMover"] = "TOPRIGHT,UIParent,TOPRIGHT,-428,-515" --new
	E.db["movers"]["ElvUF_TargetAuraMover"] = "BOTTOMRIGHT,ElvUIParent,BOTTOMRIGHT,-400,288"
	E.db["movers"]["ElvUF_TargetCastbarMover"] = "BOTTOM,ElvUIParent,BOTTOM,311,359"
	E.db["movers"]["ElvUF_TargetMover"] = "BOTTOM,ElvUIParent,BOTTOM,280,387"
	E.db["movers"]["ElvUF_TargetTargetMover"] = "BOTTOMRIGHT,ElvUIParent,BOTTOMRIGHT,-423,387"
	E.db["movers"]["ElvUIBagMover"] = "BOTTOMRIGHT,ElvUIParent,BOTTOMRIGHT,0,24"
	E.db["movers"]["ElvUIBankMover"] = "BOTTOMLEFT,ElvUIParent,BOTTOMLEFT,0,24"
	E.db["movers"]["EnhancedVehicleBar_Mover"] = "BOTTOM,ElvUIParent,BOTTOM,0,-1"
	E.db["movers"]["MawBuffsBelowMinimapMover"] = "TOPRIGHT,ElvUIParent,TOPRIGHT,-4,-260"
	E.db["movers"]["ReputationBarMover"] = "TOP,ElvUIParent,TOP,0,0"
	E.db["movers"]["ExperienceBarMover"] = "TOP,ElvUIParent,TOP,0,-13"
	E.db["movers"]["GMMover"] = "TOP,ElvUIParent,TOP,239,-3"
	E.db["movers"]["HonorBarMover"] = "BOTTOMRIGHT,ElvUIParent,BOTTOMRIGHT,-412,0"
	--E.db["movers"]["LeftChatMover"] = "BOTTOMLEFT,ElvUIParent,BOTTOMLEFT,-1,0"
	E.db["movers"]["LootFrameMover"] = "TOPLEFT,ElvUIParent,TOPLEFT,274,-132"
	E.db["movers"]["LossControlMover"] = "TOP,ElvUIParent,TOP,0,-317"
	E.db["movers"]["MasterExperienceMover"] = "TOPLEFT,ElvUIParent,TOPLEFT,4,-349"
	E.db["movers"]["MinimapButtonAnchor"] = "TOPRIGHT,ElvUIParent,TOPRIGHT,0,-223"
	E.db["movers"]["MinimapMover"] = "TOPRIGHT,ElvUIParent,TOPRIGHT,-6,-3"
	E.db["movers"]["MirrorTimer1Mover"] = "TOP,ElvUIParent,TOP,-1,-96"
	E.db["movers"]["ObjectiveFrameMover"] = "TOPRIGHT,ElvUIParent,TOPRIGHT,-65,-319"
	if E.TBC or E.Classic then
		E.db["movers"]["QuestTimerFrameMover"] = "TOPRIGHT,ElvUIParent,TOPRIGHT,-258,-231"
		E.db["movers"]["QuestWatchFrameMover"] = "TOPRIGHT,ElvUIParent,TOPRIGHT,-223,-304"
	elseif E.Wrath then
		E.db["movers"]["WatchFrameMover"] = "TOPRIGHT,UIParent,TOPRIGHT,-115,-306"
		E.db["movers"]["ObjectiveFrameMover"] = "TOPRIGHT,ElvUIParent,TOPRIGHT,-110,-319"
	end
	E.db["movers"]["PetAB"] = "BOTTOMLEFT,ElvUIParent,BOTTOMLEFT,426,255"
	E.db["movers"]["PetBattleABMover"] = "BOTTOM,ElvUIParent,BOTTOM,0,-1"
	E.db["movers"]["PetBattleStatusMover"] = "TOP,ElvUIParent,TOP,0,1"
	E.db["movers"]["PowerWidgetMover"] = "TOP,ElvUIParent,TOP,0,-102"
	E.db["movers"]["TopCenterContainerMover"] = "TOP,ElvUIParent,TOP,0,-72"
	E.db["movers"]["RaidMarkerBarAnchor"] = "TOPLEFT,ElvUIParent,TOPLEFT,398,1"
	--E.db["movers"]["RaidUtility_Mover"] = "TOP,ElvUIParent,TOP,-220,1" --has been removed from SLE
	--E.db["movers"]["MicrobarMover"] = "BOTTOMRIGHT,ElvUIParent,BOTTOMRIGHT,-412,23" --moved since it was overlapping with datatext
	E.db["movers"]["MicrobarMover"] = "TOPLEFT,ElvUIParent,TOPLEFT,140,1"
	--E.db["movers"]["MicrobarMover"] = "TOPLEFT,UIParent,TOPLEFT,4,-4"
	--E.db["movers"]["MicrobarMover"] = "TOPLEFT,ElvUIParent,TOPLEFT,341,-2"
	--E.db["movers"]["RightChatMover"] = "BOTTOMRIGHT,ElvUIParent,BOTTOMRIGHT,0,0"
	if IsAddOnLoaded("ElvUI_SLE") then
		E.db["movers"]["SLE_DataPanel_1_Mover"] = "BOTTOMRIGHT,ElvUIParent,BOTTOMRIGHT,-4,202"
		E.db["movers"]["SLE_FarmSeedMover"] = "BOTTOMLEFT,ElvUIParent,BOTTOMLEFT,4,278"
	end
	E.db["movers"]["ShiftAB"] = "BOTTOM,ElvUIParent,BOTTOM,-308,308"
	E.db["movers"]["SocialMenuMover"] = "TOPLEFT,ElvUIParent,TOPLEFT,4,-456"
	E.db["movers"]["SquareMinimapBar"] = "TOPRIGHT,ElvUIParent,TOPRIGHT,0,-197"
	E.db["movers"]["TalkingHeadFrameMover"] = "TOPLEFT,ElvUIParent,TOPLEFT,274,-77"
	E.db["movers"]["ThreatBarMover"] = "BOTTOMLEFT,ElvUIParent,BOTTOMLEFT,0,-1"
	E.db["movers"]["TooltipMover"] = "TOPLEFT,ElvUIParent,TOPLEFT,274,-134"
	E.db["movers"]["TorghastBuffsMover"] = "BOTTOMLEFT,ElvUIParent,BOTTOMLEFT,4,206"
	E.db["movers"]["TotemBarMover"] = "BOTTOM,ElvUIParent,BOTTOM,-310,307"
	if E.Wrath then
		--Shaman things
		E.db["general"]["totems"]["buttonSize"] = 25
		E.db["general"]["totems"]["flyoutSize"] = 25
		E.db["general"]["totems"]["flyoutSpacing"] = 3
		E.db["general"]["totems"]["spacing"] = 5
		E.db["general"]["totems"]["font"] = "Kimberley"
		--E.db["general"]["totems"]["visibility"] = "[vehicleui] hide; [overridebar] hide; [possessbar] hide; [petbattle] hide; show"
		E.db["general"]["totems"]["visibility"] = "[combat] show;[@target, noexists] hide; [vehicleui] hide; [overridebar] hide; [possessbar] hide; [petbattle] hide; show"
	end

	E.db["movers"]["TorghastChoiceToggle"] = "BOTTOM,UIParent,BOTTOM,0,445"
	E.db["movers"]["VOICECHAT"] = "TOPLEFT,ElvUIParent,TOPLEFT,0,-1"
	if E.Retail then
		E.db["movers"]["VehicleLeaveButton"] = "TOPRIGHT,ElvUIParent,TOPRIGHT,-183,-179"
	else
		E.db["movers"]["VehicleLeaveButton"] = "TOPRIGHT,UIParent,TOPRIGHT,-176,-145"
	end
	E.db["movers"]["VehicleSeatMover"] = "TOPRIGHT,ElvUIParent,TOPRIGHT,-210,-150"
	if IsAddOnLoaded("ElvUI_WindTools") then
		E.db["movers"]["WTRaidMarkersBarAnchor"] = "TOPLEFT,ElvUIParent,TOPLEFT,398,1"
		E.db["movers"]["WTCustomEmoteFrameMover"] = "TOPLEFT,ElvUIParent,TOPLEFT,4,-24"
		E.db["movers"]["WTExtraItemsBar1Mover"] = "BOTTOMRIGHT,ElvUIParent,BOTTOMRIGHT,-239,231"
		E.db["movers"]["WTExtraItemsBar2Mover"] = "BOTTOMRIGHT,ElvUIParent,BOTTOMRIGHT,-239,275"
		E.db["movers"]["WTExtraItemsBar3Mover"] = "BOTTOMRIGHT,ElvUIParent,BOTTOMRIGHT,-239,310"
		E.db["movers"]["WTExtraItemsBar4Mover"] = "BOTTOMRIGHT,ElvUIParent,BOTTOMRIGHT,-239,351"
		E.db["movers"]["WTExtraItemsBar5Mover"] = "BOTTOMRIGHT,ElvUIParent,BOTTOMRIGHT,-239,391"
		E.db["movers"]["WTParagonReputationToastFrameMover"] = "TOP,ElvUIParent,TOP,0,-222"
	end
	E.db["movers"]["ZoneAbility"] = "BOTTOMRIGHT,ElvUIParent,BOTTOMRIGHT,-458,73"
	E.db["movers"]["MoverEltruismWA"] = "BOTTOM,UIParent,BOTTOM,0,264"
	E.db["movers"]["MoverEltruismWA2"] = "TOPLEFT,UIParent,TOPLEFT,18,-514"
	E.db["movers"]["MoverEltruismWAConsumables"] = "BOTTOM,ElvUIParent,BOTTOM,-280,357"

	-- UnitFrames Healing
	E.db["unitframe"]["colors"]["auraBarBuff"]["b"] = classcolor.b
	E.db["unitframe"]["colors"]["auraBarBuff"]["g"] = classcolor.g
	E.db["unitframe"]["colors"]["auraBarBuff"]["r"] = classcolor.r
	E.db["unitframe"]["colors"]["aurabar_backdrop"]["b"] = 0
	E.db["unitframe"]["colors"]["aurabar_backdrop"]["g"] = 0
	E.db["unitframe"]["colors"]["aurabar_backdrop"]["r"] = 0
	E.db["unitframe"]["colors"]["castClassColor"] = true
	E.db["unitframe"]["colors"]["castColor"]["b"] = classcolor.b
	E.db["unitframe"]["colors"]["castColor"]["g"] = classcolor.g
	E.db["unitframe"]["colors"]["castColor"]["r"] = classcolor.r
	E.db["unitframe"]["colors"]["castbar_backdrop"]["b"] = 0
	E.db["unitframe"]["colors"]["castbar_backdrop"]["g"] = 0
	E.db["unitframe"]["colors"]["castbar_backdrop"]["r"] = 0
	E.db["unitframe"]["colors"]["castReactionColor"] = true
	E.db["unitframe"]["colors"]["classResources"]["PALADIN"]["b"] = 0.070588235294118
	E.db["unitframe"]["colors"]["classResources"]["PALADIN"]["g"] = 0.98823529411765
	E.db["unitframe"]["colors"]["classResources"]["PALADIN"]["r"] = 1
	--E.db["unitframe"]["colors"]["classResources"]["DEATHKNIGHT"][0]["b"] = 1
	--E.db["unitframe"]["colors"]["classResources"]["DEATHKNIGHT"][0]["g"] = 1
	--E.db["unitframe"]["colors"]["classResources"]["DEATHKNIGHT"][0]["r"] = 0
	E.db["unitframe"]["colors"]["classbackdrop"] = true
	E.db["unitframe"]["colors"]["classpower_backdrop"]["b"] = 0
	E.db["unitframe"]["colors"]["classpower_backdrop"]["g"] = 0
	E.db["unitframe"]["colors"]["classpower_backdrop"]["r"] = 0
	E.db["unitframe"]["colors"]["healthclass"] = false
	E.db["unitframe"]["colors"]["customhealthbackdrop"] = false
	E.db["unitframe"]["colors"]["health_backdrop"]["b"] = 0
	E.db["unitframe"]["colors"]["health_backdrop"]["g"] = 0
	E.db["unitframe"]["colors"]["health_backdrop"]["r"] = 0
	E.db["unitframe"]["colors"]["colorhealthbyvalue"] = false
	E.db["unitframe"]["colors"]["customclasspowerbackdrop"] = true
	E.db["unitframe"]["colors"]["classpower_backdrop"]["b"] = 0
	E.db["unitframe"]["colors"]["classpower_backdrop"]["g"] = 0
	E.db["unitframe"]["colors"]["classpower_backdrop"]["r"] = 0
	E.db["unitframe"]["colors"]["customaurabarbackdrop"] = true
	E.db["unitframe"]["colors"]["customcastbarbackdrop"] = true
	E.db["unitframe"]["colors"]["custompowerbackdrop"] = true
	E.db["unitframe"]["colors"]["frameGlow"]["mainGlow"]["class"] = true
	E.db["unitframe"]["colors"]["frameGlow"]["mainGlow"]["enable"] = true
	E.db["unitframe"]["colors"]["frameGlow"]["mouseoverGlow"]["class"] = true
	E.db["unitframe"]["colors"]["frameGlow"]["mouseoverGlow"]["color"]["a"] = 1
	E.db["unitframe"]["colors"]["frameGlow"]["mouseoverGlow"]["enable"] = false
	E.db["unitframe"]["colors"]["health"]["b"] = 0
	E.db["unitframe"]["colors"]["health"]["g"] = 0
	E.db["unitframe"]["colors"]["health"]["r"] = 0
	E.db["unitframe"]["colors"]["healthMultiplier"] = 0.75
	E.db["unitframe"]["colors"]["health_backdrop"]["b"] = classcolor.b
	E.db["unitframe"]["colors"]["health_backdrop"]["g"] = classcolor.g
	E.db["unitframe"]["colors"]["health_backdrop"]["r"] = classcolor.r
	E.db["unitframe"]["colors"]["health_backdrop_dead"]["b"] = 0
	E.db["unitframe"]["colors"]["health_backdrop_dead"]["g"] = 0
	E.db["unitframe"]["colors"]["health_backdrop_dead"]["r"] = 0
	E.db["unitframe"]["colors"]["healPrediction"]["healAbsorbs"]["a"] = 0.35
	E.db["unitframe"]["colors"]["healPrediction"]["others"]["a"] = 0.35
	E.db["unitframe"]["colors"]["healPrediction"]["overabsorbs"]["a"] = 0.35
	E.db["unitframe"]["colors"]["healPrediction"]["overhealabsorbs"]["a"] = 0.35
	E.db["unitframe"]["colors"]["healPrediction"]["personal"]["a"] = 0.35
	E.db["unitframe"]["colors"]["power"]["ALT_POWER"]["b"] = 0.8
	E.db["unitframe"]["colors"]["power"]["ALT_POWER"]["g"] = 0.40
	E.db["unitframe"]["colors"]["power"]["ALT_POWER"]["r"] = 0.2
	E.db["unitframe"]["colors"]["power"]["ENERGY"]["b"] = 0.54
	E.db["unitframe"]["colors"]["power"]["ENERGY"]["g"] = 0.97
	E.db["unitframe"]["colors"]["power"]["ENERGY"]["r"] = 1
	E.db["unitframe"]["colors"]["power"]["FOCUS"]["b"] = 0.25
	E.db["unitframe"]["colors"]["power"]["FOCUS"]["g"] = 0.50
	E.db["unitframe"]["colors"]["power"]["FOCUS"]["r"] = 1
	E.db["unitframe"]["colors"]["power"]["FURY"]["b"] = 1
	E.db["unitframe"]["colors"]["power"]["FURY"]["g"] = 0.26
	E.db["unitframe"]["colors"]["power"]["FURY"]["r"] = 0.79
	E.db["unitframe"]["colors"]["power"]["INSANITY"]["b"] = 1
	E.db["unitframe"]["colors"]["power"]["INSANITY"]["g"] = 0.25
	E.db["unitframe"]["colors"]["power"]["INSANITY"]["r"] = 0.50
	E.db["unitframe"]["colors"]["power"]["LUNAR_POWER"]["b"] = 0.90
	E.db["unitframe"]["colors"]["power"]["LUNAR_POWER"]["g"] = 0.52
	E.db["unitframe"]["colors"]["power"]["LUNAR_POWER"]["r"] = 0.30
	E.db["unitframe"]["colors"]["power"]["MAELSTROM"]["r"] = 0
	E.db["unitframe"]["colors"]["power"]["MAELSTROM"]["g"] = 0.5
	E.db["unitframe"]["colors"]["power"]["MAELSTROM"]["b"] = 1
	E.db["unitframe"]["colors"]["power"]["MANA"]["b"] = 1
	E.db["unitframe"]["colors"]["power"]["MANA"]["g"] = 0.71
	E.db["unitframe"]["colors"]["power"]["MANA"]["r"] = 0.49
	E.db["unitframe"]["colors"]["power"]["PAIN"]["r"] = 1
	E.db["unitframe"]["colors"]["power"]["PAIN"]["g"] = 0.61
	E.db["unitframe"]["colors"]["power"]["PAIN"]["b"] = 0
	E.db["unitframe"]["colors"]["power"]["RAGE"]["b"] = 0.32
	E.db["unitframe"]["colors"]["power"]["RAGE"]["g"] = 0.32
	E.db["unitframe"]["colors"]["power"]["RAGE"]["r"] = 1
	E.db["unitframe"]["colors"]["power"]["RUNIC_POWER"]["r"] = 0
	E.db["unitframe"]["colors"]["power"]["RUNIC_POWER"]["g"] = 0.82
	E.db["unitframe"]["colors"]["power"]["RUNIC_POWER"]["b"] = 1
	E.db["unitframe"]["colors"]["power_backdrop"]["b"] = 0
	E.db["unitframe"]["colors"]["power_backdrop"]["g"] = 0
	E.db["unitframe"]["colors"]["power_backdrop"]["r"] = 0
	E.db["unitframe"]["colors"]["transparentAurabars"] = true
	E.db["unitframe"]["colors"]["transparentCastbar"] = true
	E.db["unitframe"]["colors"]["transparentHealth"] = true
	--E.db["unitframe"]["colors"]["transparentPower"] = true
	E.db["unitframe"]["colors"]["transparentPower"] = false
	E.db["unitframe"]["debuffHighlighting"] = "GLOW"
	E.db["unitframe"]["statusbar"] = "ElvUI Norm1"
	E.db["unitframe"]["font"] = "Kimberley"
	E.db["unitframe"]["fontOutline"] = "OUTLINE"
	E.db["unitframe"]["smartRaidFilter"] = false
	E.db["unitframe"]["targetSound"] = true
	E.db["unitframe"]["units"]["arena"]["buffs"]["countFont"] = "Kimberley"
	E.db["unitframe"]["units"]["arena"]["buffs"]["countXOffset"] = 2
	E.db["unitframe"]["units"]["arena"]["buffs"]["countYOffset"] = -3
	E.db["unitframe"]["units"]["arena"]["buffs"]["durationPosition"] = "TOP"
	E.db["unitframe"]["units"]["arena"]["buffs"]["height"] = 25
	E.db["unitframe"]["units"]["arena"]["buffs"]["keepSizeRatio"] = false
	E.db["unitframe"]["units"]["arena"]["buffs"]["perrow"] = 6
	E.db["unitframe"]["units"]["arena"]["buffs"]["sizeOverride"] = 30
	E.db["unitframe"]["units"]["arena"]["buffs"]["xOffset"] = -3
	E.db["unitframe"]["units"]["arena"]["buffs"]["yOffset"] = 14
	E.db["unitframe"]["units"]["arena"]["castbar"]["customColor"]["enable"] = true
	E.db["unitframe"]["units"]["arena"]["castbar"]["height"] = 15
	E.db["unitframe"]["units"]["arena"]["castbar"]["overlayOnFrame"] = "InfoPanel"
	E.db["unitframe"]["units"]["arena"]["castbar"]["strataAndLevel"]["frameStrata"] = "HIGH"
	E.db["unitframe"]["units"]["arena"]["castbar"]["timeToHold"] = 0.5
	E.db["unitframe"]["units"]["arena"]["castbar"]["width"] = 250
	E.db["unitframe"]["units"]["arena"]["colorOverride"] = "FORCE_OFF"
	E.db["unitframe"]["units"]["arena"]["debuffs"]["anchorPoint"] = "BOTTOM"
	E.db["unitframe"]["units"]["arena"]["debuffs"]["attachTo"] = "BUFFS"
	E.db["unitframe"]["units"]["arena"]["debuffs"]["countFont"] = "Kimberley"
	E.db["unitframe"]["units"]["arena"]["debuffs"]["countXOffset"] = 2
	E.db["unitframe"]["units"]["arena"]["debuffs"]["countYOffset"] = -3
	E.db["unitframe"]["units"]["arena"]["debuffs"]["height"] = 25
	E.db["unitframe"]["units"]["arena"]["debuffs"]["keepSizeRatio"] = false
	E.db["unitframe"]["units"]["arena"]["debuffs"]["perrow"] = 6
	E.db["unitframe"]["units"]["arena"]["debuffs"]["sizeOverride"] = 30
	E.db["unitframe"]["units"]["arena"]["debuffs"]["yOffset"] = -4
	E.db["unitframe"]["units"]["arena"]["fader"]["minAlpha"] = 0.5
	E.db["unitframe"]["units"]["arena"]["health"]["text_format"] = ""
	E.db["unitframe"]["units"]["arena"]["health"]["xOffset"] = 0
	E.db["unitframe"]["units"]["arena"]["height"] = 50
	E.db["unitframe"]["units"]["arena"]["infoPanel"]["enable"] = true
	E.db["unitframe"]["units"]["arena"]["infoPanel"]["height"] = 15
	E.db["unitframe"]["units"]["arena"]["infoPanel"]["transparent"] = true
	E.db["unitframe"]["units"]["arena"]["middleClickFocus"] = true
	E.db["unitframe"]["units"]["arena"]["name"]["text_format"] = ""
	E.db["unitframe"]["units"]["arena"]["portrait"]["overlay"] = true
	E.db["unitframe"]["units"]["arena"]["portrait"]["style"] = "Class"
	E.db["unitframe"]["units"]["arena"]["power"]["attachTextTo"] = "Power"
	E.db["unitframe"]["units"]["arena"]["power"]["height"] = 14
	E.db["unitframe"]["units"]["arena"]["power"]["powerPrediction"] = true
	E.db["unitframe"]["units"]["arena"]["power"]["text_format"] = ""
	E.db["unitframe"]["units"]["arena"]["pvpTrinket"]["size"] = 50
	E.db["unitframe"]["units"]["arena"]["pvpTrinket"]["xOffset"] = 0
	E.db["unitframe"]["units"]["arena"]["pvpTrinket"]["yOffset"] = 8
	E.db["unitframe"]["units"]["arena"]["pvpclassificationindicator"]["size"] = 30
	E.db["unitframe"]["units"]["arena"]["spacing"] = 10
	E.db["unitframe"]["units"]["arena"]["width"] = 250
	E.db["unitframe"]["units"]["assist"]["height"] = 30
	E.db["unitframe"]["units"]["assist"]["verticalSpacing"] = 1
	E.db["unitframe"]["units"]["assist"]["colorOverride"] = "FORCE_OFF"
	E.db["unitframe"]["units"]["assist"]["healPrediction"]["enable"] = true
	E.db["unitframe"]["units"]["assist"]["targetsGroup"]["enable"] = false
	E.db["unitframe"]["units"]["assist"]["targetsGroup"]["height"] = 25
	E.db["unitframe"]["units"]["assist"]["targetsGroup"]["xOffset"] = -3
	E.db["unitframe"]["units"]["assist"]["buffIndicator"]["enable"] = true
	E.db["unitframe"]["units"]["assist"]["buffIndicator"]["size"] = 12
	E.db["unitframe"]["units"]["assist"]["buffs"]["countFont"] = "Kimberley"
	E.db["unitframe"]["units"]["assist"]["buffs"]["enable"] = true
	E.db["unitframe"]["units"]["assist"]["buffs"]["priority"] = "Blacklist,TurtleBuffs,RaidBuffsElvUI"
	E.db["unitframe"]["units"]["assist"]["buffs"]["sizeOverride"] = 30
	E.db["unitframe"]["units"]["assist"]["debuffs"]["attachTo"] = "BUFFS"
	E.db["unitframe"]["units"]["assist"]["debuffs"]["countFont"] = "Kimberley"
	E.db["unitframe"]["units"]["assist"]["debuffs"]["enable"] = true
	E.db["unitframe"]["units"]["assist"]["debuffs"]["sizeOverride"] = 30
	E.db["unitframe"]["units"]["assist"]["debuffs"]["yOffset"] = 2
	E.db["unitframe"]["units"]["assist"]["rdebuffs"]["duration"]["yOffset"] = 3
	E.db["unitframe"]["units"]["assist"]["rdebuffs"]["duration"]["position"] = "TOP"
	E.db["unitframe"]["units"]["assist"]["rdebuffs"]["font"] = "Kimberley"
	E.db["unitframe"]["units"]["assist"]["rdebuffs"]["fontSize"] = 14
	E.db["unitframe"]["units"]["assist"]["rdebuffs"]["fontOutline"] = "OUTLINE"
	E.db["unitframe"]["units"]["assist"]["rdebuffs"]["yOffset"] = 0
	E.db["unitframe"]["units"]["assist"]["rdebuffs"]["size"] = 20
	E.db["unitframe"]["units"]["assist"]["rdebuffs"]["stack"]["xOffset"] = -3
	E.db["unitframe"]["units"]["tank"]["colorOverride"] = "FORCE_OFF"
	E.db["unitframe"]["units"]["tank"]["buffIndicator"]["size"] = 12
	E.db["unitframe"]["units"]["tank"]["buffs"]["countFont"] = "Kimberley"
	E.db["unitframe"]["units"]["tank"]["buffs"]["enable"] = true
	E.db["unitframe"]["units"]["tank"]["buffs"]["priority"] = "Blacklist,TurtleBuffs,RaidBuffsElvUI"
	E.db["unitframe"]["units"]["tank"]["buffs"]["sizeOverride"] = 30
	E.db["unitframe"]["units"]["tank"]["debuffs"]["attachTo"] = "BUFFS"
	E.db["unitframe"]["units"]["tank"]["debuffs"]["countFont"] = "Kimberley"
	E.db["unitframe"]["units"]["tank"]["debuffs"]["enable"] = true
	E.db["unitframe"]["units"]["tank"]["debuffs"]["priority"] = "Blacklist,Boss,RaidDebuffs,CCDebuffs,Dispellable,Whitelist"
	E.db["unitframe"]["units"]["tank"]["debuffs"]["sizeOverride"] = 30
	E.db["unitframe"]["units"]["tank"]["debuffs"]["yOffset"] = 2
	E.db["unitframe"]["units"]["tank"]["height"] = 30
	E.db["unitframe"]["units"]["tank"]["rdebuffs"]["fontOutline"] = "OUTLINE"
	E.db["unitframe"]["units"]["tank"]["rdebuffs"]["duration"]["yOffset"] = 3
	E.db["unitframe"]["units"]["tank"]["rdebuffs"]["font"] = "Kimberley"
	E.db["unitframe"]["units"]["tank"]["rdebuffs"]["fontOutline"] = "OUTLINE"
	E.db["unitframe"]["units"]["tank"]["rdebuffs"]["fontSize"] = 14
	E.db["unitframe"]["units"]["tank"]["rdebuffs"]["size"] = 20
	E.db["unitframe"]["units"]["tank"]["rdebuffs"]["stack"]["xOffset"] = -3
	E.db["unitframe"]["units"]["tank"]["verticalSpacing"] = 7
	E.db["unitframe"]["units"]["tank"]["targetsGroup"]["anchorPoint"] = "LEFT"
	E.db["unitframe"]["units"]["tank"]["targetsGroup"]["height"] = 30
	E.db["unitframe"]["units"]["tank"]["targetsGroup"]["xOffset"] = -3
	E.db["unitframe"]["units"]["boss"]["castbar"]["overlayOnFrame"] = "InfoPanel"
	E.db["unitframe"]["units"]["boss"]["castbar"]["customColor"]["enable"] = true
	E.db["unitframe"]["units"]["boss"]["height"] = 45
	E.db["unitframe"]["units"]["boss"]["spacing"] = 10
	E.db["unitframe"]["units"]["boss"]["smartAuraPosition"] = "FLUID_BUFFS_ON_DEBUFFS"
	E.db["unitframe"]["units"]["boss"]["colorOverride"] = "FORCE_OFF"
	E.db["unitframe"]["units"]["boss"]["fader"]["enable"] = false
	E.db["unitframe"]["units"]["boss"]["fader"]["range"] = false
	E.db["unitframe"]["units"]["boss"]["portrait"]["enable"] = true
	E.db["unitframe"]["units"]["boss"]["portrait"]["fullOverlay"] = true
	E.db["unitframe"]["units"]["boss"]["portrait"]["overlay"] = true
	E.db["unitframe"]["units"]["boss"]["buffIndicator"]["size"] = 15
	E.db["unitframe"]["units"]["boss"]["buffs"]["anchorPoint"] = "TOPRIGHT"
	E.db["unitframe"]["units"]["boss"]["buffs"]["attachTo"] = "DEBUFFS"
	E.db["unitframe"]["units"]["boss"]["buffs"]["countFont"] = "Kimberley"
	E.db["unitframe"]["units"]["boss"]["buffs"]["countXOffset"] = 3
	E.db["unitframe"]["units"]["boss"]["buffs"]["countYOffset"] = -6
	E.db["unitframe"]["units"]["boss"]["buffs"]["durationPosition"] = "TOP"
	E.db["unitframe"]["units"]["boss"]["buffs"]["growthX"] = "LEFT"
	E.db["unitframe"]["units"]["boss"]["buffs"]["height"] = 21
	E.db["unitframe"]["units"]["boss"]["buffs"]["keepSizeRatio"] = false
	E.db["unitframe"]["units"]["boss"]["buffs"]["perrow"] = 7
	E.db["unitframe"]["units"]["boss"]["buffs"]["sizeOverride"] = 30
	E.db["unitframe"]["units"]["boss"]["buffs"]["xOffset"] = -1
	E.db["unitframe"]["units"]["boss"]["buffs"]["yOffset"] = 3
	E.db["unitframe"]["units"]["boss"]["buffs"]["spacing"] = 2
	E.db["unitframe"]["units"]["boss"]["debuffs"]["countFont"] = "Kimberley"
	E.db["unitframe"]["units"]["boss"]["debuffs"]["countXOffset"] = 3
	E.db["unitframe"]["units"]["boss"]["debuffs"]["countYOffset"] = -6
	E.db["unitframe"]["units"]["boss"]["debuffs"]["durationPosition"] = "TOP"
	E.db["unitframe"]["units"]["boss"]["debuffs"]["growthX"] = "LEFT"
	E.db["unitframe"]["units"]["boss"]["debuffs"]["height"] = 21
	E.db["unitframe"]["units"]["boss"]["debuffs"]["keepSizeRatio"] = false
	E.db["unitframe"]["units"]["boss"]["debuffs"]["perrow"] = 7
	E.db["unitframe"]["units"]["boss"]["debuffs"]["sizeOverride"] = 30
	E.db["unitframe"]["units"]["boss"]["debuffs"]["xOffset"] = -3
	E.db["unitframe"]["units"]["boss"]["debuffs"]["yOffset"] = -13
	E.db["unitframe"]["units"]["boss"]["debuffs"]["spacing"] = 2
	E.db["unitframe"]["units"]["focus"]["colorOverride"] = "FORCE_OFF"
	E.db["unitframe"]["units"]["focus"]["healPrediction"]["absorbStyle"] = "REVERSED"
	E.db["unitframe"]["units"]["focus"]["CombatIcon"]["xOffset"] = -87
	E.db["unitframe"]["units"]["focus"]["CombatIcon"]["yOffset"] = 10
	E.db["unitframe"]["units"]["focus"]["buffIndicator"]["size"] = 20
	E.db["unitframe"]["units"]["focus"]["castbar"]["customColor"]["colorBackdrop"]["a"] = 0
	E.db["unitframe"]["units"]["focus"]["castbar"]["customColor"]["colorBackdrop"]["b"] = 0
	E.db["unitframe"]["units"]["focus"]["castbar"]["customColor"]["colorBackdrop"]["g"] = 0
	E.db["unitframe"]["units"]["focus"]["castbar"]["customColor"]["colorBackdrop"]["r"] = 0
	--E.db["unitframe"]["units"]["focus"]["castbar"]["customColor"]["enable"] = false
	E.db["unitframe"]["units"]["focus"]["castbar"]["customColor"]["enable"] = true
	E.db["unitframe"]["units"]["focus"]["castbar"]["customColor"]["invertColors"] = false
	E.db["unitframe"]["units"]["focus"]["castbar"]["customColor"]["useClassColor"] = true
	E.db["unitframe"]["units"]["focus"]["castbar"]["customColor"]["useCustomBackdrop"] = true
	E.db["unitframe"]["units"]["focus"]["castbar"]["height"] = 30
	E.db["unitframe"]["units"]["focus"]["castbar"]["width"] = 333
	E.db["unitframe"]["units"]["focus"]["disableMouseoverGlow"] = true
	E.db["unitframe"]["units"]["focus"]["disableTargetGlow"] = true
	E.db["unitframe"]["units"]["focus"]["castbar"]["strataAndLevel"]["frameStrata"] = "DIALOG"
	E.db["unitframe"]["units"]["focus"]["castbar"]["timeToHold"] = 1
	E.db["unitframe"]["units"]["focus"]["debuffs"]["countFont"] = "Kimberley"
	E.db["unitframe"]["units"]["focus"]["debuffs"]["countFontOutline"] = "OUTLINE"
	E.db["unitframe"]["units"]["focus"]["debuffs"]["anchorPoint"] = "TOP"
	E.db["unitframe"]["units"]["focus"]["debuffs"]["countXOffset"] = 2
	E.db["unitframe"]["units"]["focus"]["debuffs"]["countYOffset"] = -3
	E.db["unitframe"]["units"]["focus"]["debuffs"]["durationPosition"] = "TOP"
	E.db["unitframe"]["units"]["focus"]["debuffs"]["height"] = 25
	E.db["unitframe"]["units"]["focus"]["debuffs"]["keepSizeRatio"] = false
	E.db["unitframe"]["units"]["focus"]["debuffs"]["sizeOverride"] = 30
	E.db["unitframe"]["units"]["focus"]["height"] = 35
	E.db["unitframe"]["units"]["focus"]["infoPanel"]["enable"] = true
	E.db["unitframe"]["units"]["focus"]["name"]["text_format"] = "[namecolor][name:eltruism:abbreviate] [eltruism:class:player] [eltruism:raidmarker]"
	E.db["unitframe"]["units"]["focus"]["power"]["attachTextTo"] = "Power"
	E.db["unitframe"]["units"]["focus"]["power"]["height"] = 14
	E.db["unitframe"]["units"]["focus"]["power"]["position"] = "RIGHT"
	E.db["unitframe"]["units"]["focus"]["power"]["text_format"] = "[powercolor][power:current:shortvalue]"
	E.db["unitframe"]["units"]["focus"]["power"]["width"] = "spaced"
	E.db["unitframe"]["units"]["focus"]["power"]["xOffset"] = -7
	E.db["unitframe"]["units"]["focustarget"]["colorOverride"] = "FORCE_OFF"
	E.db["unitframe"]["units"]["party"]["buffIndicator"]["size"] = 16
	E.db["unitframe"]["units"]["party"]["buffs"]["anchorPoint"] = "TOP"
	E.db["unitframe"]["units"]["party"]["buffs"]["clickThrough"] = true
	E.db["unitframe"]["units"]["party"]["buffs"]["countFont"] = "Kimberley"
	E.db["unitframe"]["units"]["party"]["buffs"]["countFontSize"] = 14
	E.db["unitframe"]["units"]["party"]["buffs"]["countXOffset"] = 2
	E.db["unitframe"]["units"]["party"]["buffs"]["countYOffset"] = -3
	E.db["unitframe"]["units"]["party"]["buffs"]["durationPosition"] = "TOP"
	E.db["unitframe"]["units"]["party"]["buffs"]["enable"] = true
	E.db["unitframe"]["units"]["party"]["buffs"]["height"] = 25
	E.db["unitframe"]["units"]["party"]["buffs"]["keepSizeRatio"] = false
	E.db["unitframe"]["units"]["party"]["buffs"]["perrow"] = 6
	E.db["unitframe"]["units"]["party"]["buffs"]["sizeOverride"] = 24
	E.db["unitframe"]["units"]["party"]["buffs"]["yOffset"] = 1
	E.db["unitframe"]["units"]["party"]["colorOverride"] = "FORCE_OFF"
	E.db["unitframe"]["units"]["party"]["debuffs"]["anchorPoint"] = "TOP"
	E.db["unitframe"]["units"]["party"]["debuffs"]["attachTo"] = "BUFFS"
	E.db["unitframe"]["units"]["party"]["debuffs"]["countFont"] = "Kimberley"
	E.db["unitframe"]["units"]["party"]["debuffs"]["countFontSize"] = 10
	E.db["unitframe"]["units"]["party"]["debuffs"]["countXOffset"] = 2
	E.db["unitframe"]["units"]["party"]["debuffs"]["countYOffset"] = -3
	E.db["unitframe"]["units"]["party"]["debuffs"]["desaturate"] = false
	E.db["unitframe"]["units"]["party"]["debuffs"]["durationPosition"] = "TOP"
	E.db["unitframe"]["units"]["party"]["debuffs"]["height"] = 25
	E.db["unitframe"]["units"]["party"]["debuffs"]["keepSizeRatio"] = false
	E.db["unitframe"]["units"]["party"]["debuffs"]["numrows"] = 2
	E.db["unitframe"]["units"]["party"]["debuffs"]["perrow"] = 6
	E.db["unitframe"]["units"]["party"]["debuffs"]["sizeOverride"] = 24
	E.db["unitframe"]["units"]["party"]["debuffs"]["yOffset"] = 1
	E.db["unitframe"]["units"]["party"]["groupBy"] = "ROLE"
	E.db["unitframe"]["units"]["party"]["healPrediction"]["absorbStyle"] = "REVERSED"
	E.db["unitframe"]["units"]["party"]["healPrediction"]["enable"] = true
	E.db["unitframe"]["units"]["party"]["health"]["attachTextTo"] = "InfoPanel"
	E.db["unitframe"]["units"]["party"]["health"]["position"] = "RIGHT"
	E.db["unitframe"]["units"]["party"]["health"]["text_format"] = ""
	E.db["unitframe"]["units"]["party"]["health"]["xOffset"] = 0
	E.db["unitframe"]["units"]["party"]["height"] = 60
	E.db["unitframe"]["units"]["party"]["horizontalSpacing"] = 9
	E.db["unitframe"]["units"]["party"]["infoPanel"]["enable"] = true
	E.db["unitframe"]["units"]["party"]["infoPanel"]["height"] = 16
	E.db["unitframe"]["units"]["party"]["name"]["attachTextTo"] = "InfoPanel"
	E.db["unitframe"]["units"]["party"]["name"]["position"] = "LEFT"
	E.db["unitframe"]["units"]["party"]["name"]["text_format"] = ""
	E.db["unitframe"]["units"]["party"]["orientation"] = "RIGHT"
	E.db["unitframe"]["units"]["party"]["portrait"]["desaturation"] = 0.7
	E.db["unitframe"]["units"]["party"]["portrait"]["fullOverlay"] = true
	E.db["unitframe"]["units"]["party"]["portrait"]["overlay"] = true
	E.db["unitframe"]["units"]["party"]["portrait"]["paused"] = true
	E.db["unitframe"]["units"]["party"]["power"]["attachTextTo"] = "Power"
	E.db["unitframe"]["units"]["party"]["power"]["height"] = 12
	E.db["unitframe"]["units"]["party"]["power"]["text_format"] = ""
	E.db["unitframe"]["units"]["party"]["power"]["xOffset"] = 0
	E.db["unitframe"]["units"]["party"]["raidicon"]["attachTo"] = "TOPRIGHT"
	E.db["unitframe"]["units"]["party"]["raidicon"]["size"] = 24
	E.db["unitframe"]["units"]["party"]["raidicon"]["yOffset"] = 0
	E.db["unitframe"]["units"]["party"]["raidicon"]["enable"] = false
	E.db["unitframe"]["units"]["party"]["rdebuffs"]["fontSize"] = 12
	E.db["unitframe"]["units"]["party"]["rdebuffs"]["size"] = 22
	E.db["unitframe"]["units"]["party"]["rdebuffs"]["xOffset"] = -35
	E.db["unitframe"]["units"]["party"]["rdebuffs"]["yOffset"] = 40
	E.db["unitframe"]["units"]["party"]["rdebuffs"]["font"] = "Kimberley"
	E.db["unitframe"]["units"]["party"]["rdebuffs"]["fontOutline"] = "OUTLINE"
	E.db["unitframe"]["units"]["party"]["readycheckIcon"]["attachTo"] = "CENTER"
	E.db["unitframe"]["units"]["party"]["resurrectIcon"]["attachToObject"] = "Health"
	E.db["unitframe"]["units"]["party"]["roleIcon"]["size"] = 16
	E.db["unitframe"]["units"]["party"]["roleIcon"]["yOffset"] = 0
	E.db["unitframe"]["units"]["party"]["raidRoleIcons"]["xOffset"] = 0
	E.db["unitframe"]["units"]["party"]["raidRoleIcons"]["yOffset"] = 0
	E.db["unitframe"]["units"]["party"]["sortDir"] = "DESC"
	E.db["unitframe"]["units"]["party"]["summonIcon"]["attachToObject"] = "Health"
	E.db["unitframe"]["units"]["party"]["verticalSpacing"] = 9
	E.db["unitframe"]["units"]["party"]["width"] = 150
	E.db["unitframe"]["units"]["party"]["castbar"]["customColor"]["colorBackdrop"]["b"] = 0
	E.db["unitframe"]["units"]["party"]["castbar"]["customColor"]["colorBackdrop"]["g"] = 0
	E.db["unitframe"]["units"]["party"]["castbar"]["customColor"]["colorBackdrop"]["r"] = 0
	--E.db["unitframe"]["units"]["party"]["castbar"]["customColor"]["enable"] = true
	E.db["unitframe"]["units"]["party"]["castbar"]["customColor"]["enable"] = false
	E.db["unitframe"]["units"]["party"]["castbar"]["customColor"]["useClassColor"] = true
	E.db["unitframe"]["units"]["party"]["castbar"]["customColor"]["useCustomBackdrop"] = true
	E.db["unitframe"]["units"]["party"]["castbar"]["customTextFont"]["enable"] = true
	E.db["unitframe"]["units"]["party"]["castbar"]["customTextFont"]["font"] = "Kimberley"
	E.db["unitframe"]["units"]["party"]["castbar"]["enable"] = true
	E.db["unitframe"]["units"]["party"]["castbar"]["height"] = 15
	E.db["unitframe"]["units"]["party"]["castbar"]["overlayOnFrame"] = "InfoPanel"
	E.db["unitframe"]["units"]["party"]["castbar"]["positionsGroup"]["anchorPoint"] = "LEFT"
	E.db["unitframe"]["units"]["party"]["castbar"]["textColor"]["b"] = 1
	E.db["unitframe"]["units"]["party"]["castbar"]["textColor"]["g"] = 1
	E.db["unitframe"]["units"]["party"]["castbar"]["textColor"]["r"] = 1
	E.db["unitframe"]["units"]["party"]["castbar"]["timeToHold"] = 1
	E.db["unitframe"]["units"]["party"]["castbar"]["width"] = 200
	E.db["unitframe"]["units"]["party"]["castbar"]["xOffsetText"] = 2
	if E.Wrath or E.TBC or E.Classic then
		E.db["unitframe"]["units"]["party"]["petsGroup"]["anchorPoint"] = "BOTTOM"
		E.db["unitframe"]["units"]["party"]["petsGroup"]["buffIndicator"]["enable"] = true
		E.db["unitframe"]["units"]["party"]["petsGroup"]["buffIndicator"]["size"] = 16
		E.db["unitframe"]["units"]["party"]["petsGroup"]["enable"] = true
		E.db["unitframe"]["units"]["party"]["petsGroup"]["healPrediction"]["enable"] = true
		E.db["unitframe"]["units"]["party"]["petsGroup"]["height"] = 36
		E.db["unitframe"]["units"]["party"]["petsGroup"]["width"] = 150
		E.db["unitframe"]["units"]["party"]["petsGroup"]["xOffset"] = 0
		E.db["unitframe"]["units"]["party"]["petsGroup"]["yOffset"] = -3
	end
	E.db["unitframe"]["units"]["party"]["visibility"] = "[@raid6,exists][nogroup] hide;show"
	if not E.Retail then
		E.db["unitframe"]["units"]["pet"]["health"]["colorPetByUnitClass"] = false
	end
	E.db["unitframe"]["units"]["pet"]["buffIndicator"]["size"] = 15
	E.db["unitframe"]["units"]["pet"]["buffs"]["attachTo"] = "DEBUFFS"
	E.db["unitframe"]["units"]["pet"]["buffs"]["anchorPoint"] = "TOP"
	E.db["unitframe"]["units"]["pet"]["buffs"]["attachTo"] = "DEBUFFS"
	E.db["unitframe"]["units"]["pet"]["buffs"]["countFont"] = "Kimberley"
	E.db["unitframe"]["units"]["pet"]["buffs"]["countFontOutline"] = "OUTLINE"
	E.db["unitframe"]["units"]["pet"]["buffs"]["enable"] = true
	E.db["unitframe"]["units"]["pet"]["buffs"]["growthX"] = "LEFT"
	E.db["unitframe"]["units"]["pet"]["buffs"]["spacing"] = 1
	E.db["unitframe"]["units"]["pet"]["buffs"]["xOffset"] = 0
	E.db["unitframe"]["units"]["pet"]["buffs"]["yOffset"] = 2
	E.db["unitframe"]["units"]["pet"]["buffs"]["sizeOverride"] = 25
	E.db["unitframe"]["units"]["pet"]["debuffs"]["anchorPoint"] = "TOP"
	E.db["unitframe"]["units"]["pet"]["debuffs"]["countFontOutline"] = "OUTLINE"
	E.db["unitframe"]["units"]["pet"]["debuffs"]["enable"] = true
	E.db["unitframe"]["units"]["pet"]["debuffs"]["height"] = 25
	E.db["unitframe"]["units"]["pet"]["debuffs"]["sizeOverride"] = 25
	E.db["unitframe"]["units"]["pet"]["debuffs"]["yOffset"] = 1
	E.db["unitframe"]["units"]["pet"]["castbar"]["customColor"]["colorBackdrop"]["a"] = 0
	E.db["unitframe"]["units"]["pet"]["castbar"]["customColor"]["colorBackdrop"]["b"] = 0.50196078431373
	E.db["unitframe"]["units"]["pet"]["castbar"]["customColor"]["colorBackdrop"]["g"] = 0.50196078431373
	E.db["unitframe"]["units"]["pet"]["castbar"]["customColor"]["colorBackdrop"]["r"] = 0.50196078431373
	E.db["unitframe"]["units"]["pet"]["castbar"]["customColor"]["enable"] = true
	E.db["unitframe"]["units"]["pet"]["castbar"]["customColor"]["invertColors"] = false
	E.db["unitframe"]["units"]["pet"]["castbar"]["customColor"]["transparent"] = false
	E.db["unitframe"]["units"]["pet"]["castbar"]["customColor"]["useClassColor"] = true
	E.db["unitframe"]["units"]["pet"]["castbar"]["customColor"]["useCustomBackdrop"] = true
	E.db["unitframe"]["units"]["pet"]["castbar"]["height"] = 15
	E.db["unitframe"]["units"]["pet"]["castbar"]["overlayOnFrame"] = "Health"
	E.db["unitframe"]["units"]["pet"]["castbar"]["timeToHold"] = 0.2
	E.db["unitframe"]["units"]["pet"]["castbar"]["width"] = 130
	E.db["unitframe"]["units"]["pet"]["disableTargetGlow"] = false
	E.db["unitframe"]["units"]["pet"]["fader"]["casting"] = true
	E.db["unitframe"]["units"]["pet"]["fader"]["combat"] = true
	E.db["unitframe"]["units"]["pet"]["fader"]["health"] = true
	E.db["unitframe"]["units"]["pet"]["fader"]["hover"] = true
	E.db["unitframe"]["units"]["pet"]["fader"]["minAlpha"] = 0
	E.db["unitframe"]["units"]["pet"]["fader"]["playertarget"] = true
	E.db["unitframe"]["units"]["pet"]["fader"]["power"] = true
	E.db["unitframe"]["units"]["pet"]["fader"]["range"] = false
	E.db["unitframe"]["units"]["pet"]["fader"]["unittarget"] = true
	E.db["unitframe"]["units"]["pet"]["fader"]["vehicle"] = true
	E.db["unitframe"]["units"]["pet"]["name"]["text_format"] = ""
	E.db["unitframe"]["units"]["pet"]["colorOverride"] = "FORCE_OFF"
	if E.Retail then
		E.db["unitframe"]["units"]["pet"]["power"]["enable"] = false
	elseif E.Wrath or E.TBC or E.Classic then
		E.db["unitframe"]["units"]["pet"]["power"]["enable"] = true
	end
	E.db["unitframe"]["units"]["pet"]["power"]["text_format"] = ""
	--E.db["unitframe"]["units"]["pet"]["power"]["width"] = "spaced"
	E.db["unitframe"]["units"]["pet"]["power"]["width"] = "inset"
	E.db["unitframe"]["units"]["pet"]["smartAuraPosition"] = "FLUID_BUFFS_ON_DEBUFFS"
	E.db["unitframe"]["units"]["pet"]["width"] = 100
	E.db["unitframe"]["units"]["player"]["forcehealthreaction"] = false
	E.db["unitframe"]["units"]["player"]["CombatIcon"]["anchorPoint"] = "TOPRIGHT"
	E.db["unitframe"]["units"]["player"]["CombatIcon"]["color"]["a"] = 0.80000001192093
	E.db["unitframe"]["units"]["player"]["CombatIcon"]["color"]["b"] = 1
	E.db["unitframe"]["units"]["player"]["CombatIcon"]["color"]["g"] = 1
	E.db["unitframe"]["units"]["player"]["CombatIcon"]["defaultColor"] = false
	E.db["unitframe"]["units"]["player"]["CombatIcon"]["size"] = 20
	E.db["unitframe"]["units"]["player"]["CombatIcon"]["xOffset"] = -7
	E.db["unitframe"]["units"]["player"]["CombatIcon"]["yOffset"] = -7
	E.db["unitframe"]["units"]["player"]["RestIcon"]["color"]["a"] = 0.57115608453751
	E.db["unitframe"]["units"]["player"]["RestIcon"]["defaultColor"] = false
	E.db["unitframe"]["units"]["player"]["RestIcon"]["size"] = 15
	E.db["unitframe"]["units"]["player"]["RestIcon"]["texture"] = "Resting0"
	E.db["unitframe"]["units"]["player"]["RestIcon"]["xOffset"] = 8
	E.db["unitframe"]["units"]["player"]["RestIcon"]["yOffset"] = -7
	E.db["unitframe"]["units"]["player"]["aurabar"]["attachTo"] = "FRAME"
	E.db["unitframe"]["units"]["player"]["aurabar"]["spacing"] = 1
	E.db["unitframe"]["units"]["player"]["aurabar"]["yOffset"] = 1
	E.db["unitframe"]["units"]["player"]["buffs"]["countFont"] = "Kimberley"
	E.db["unitframe"]["units"]["player"]["buffs"]["attachTo"] = "FRAME"
	E.db["unitframe"]["units"]["player"]["buffs"]["countFont"] = "Kimberley"
	E.db["unitframe"]["units"]["player"]["buffs"]["countFontOutline"] = "OUTLINE"
	E.db["unitframe"]["units"]["player"]["buffs"]["height"] = 25
	E.db["unitframe"]["units"]["player"]["buffs"]["keepSizeRatio"] = false
	E.db["unitframe"]["units"]["player"]["buffs"]["sizeOverride"] = 30
	E.db["unitframe"]["units"]["player"]["buffs"]["xOffset"] = 0
	E.db["unitframe"]["units"]["player"]["buffs"]["yOffset"] = -2
	E.db["unitframe"]["units"]["player"]["buffs"]["enable"] = false
	E.db["unitframe"]["units"]["player"]["castbar"]["customColor"]["colorBackdrop"]["a"] = 0
	E.db["unitframe"]["units"]["player"]["castbar"]["customColor"]["colorBackdrop"]["b"] = 0.50196078431373
	E.db["unitframe"]["units"]["player"]["castbar"]["customColor"]["colorBackdrop"]["g"] = 0.50196078431373
	E.db["unitframe"]["units"]["player"]["castbar"]["customColor"]["colorBackdrop"]["r"] = 0.50196078431373
	E.db["unitframe"]["units"]["player"]["castbar"]["customColor"]["colorNoInterrupt"]["b"] = 0.29803921568627
	E.db["unitframe"]["units"]["player"]["castbar"]["customColor"]["colorNoInterrupt"]["g"] = 0.78039215686275
	E.db["unitframe"]["units"]["player"]["castbar"]["customColor"]["colorNoInterrupt"]["r"] = 0
	E.db["unitframe"]["units"]["player"]["castbar"]["customColor"]["transparent"] = true
	E.db["unitframe"]["units"]["player"]["castbar"]["customColor"]["useClassColor"] = true
	E.db["unitframe"]["units"]["player"]["castbar"]["customColor"]["useCustomBackdrop"] = true
	E.db["unitframe"]["units"]["player"]["castbar"]["height"] = 28
	E.db["unitframe"]["units"]["player"]["castbar"]["iconAttached"] = false
	E.db["unitframe"]["units"]["player"]["castbar"]["iconAttachedTo"] = "Castbar"
	E.db["unitframe"]["units"]["player"]["castbar"]["iconSize"] = 27
	E.db["unitframe"]["units"]["player"]["castbar"]["iconXOffset"] = 0
	E.db["unitframe"]["units"]["player"]["castbar"]["insideInfoPanel"] = false
	E.db["unitframe"]["units"]["player"]["castbar"]["tickColor"]["a"] = 0
	E.db["unitframe"]["units"]["player"]["castbar"]["tickColor"]["b"] = 1
	E.db["unitframe"]["units"]["player"]["castbar"]["tickColor"]["g"] = 1
	E.db["unitframe"]["units"]["player"]["castbar"]["tickColor"]["r"] = 1
	E.db["unitframe"]["units"]["player"]["castbar"]["tickWidth"] = 20
	E.db["unitframe"]["units"]["player"]["castbar"]["ticks"] = false
	E.db["unitframe"]["units"]["player"]["castbar"]["timeToHold"] = 0.6
	E.db["unitframe"]["units"]["player"]["castbar"]["width"] = 267
	E.db["unitframe"]["units"]["player"]["classbar"]["fill"] = "spaced"
	E.db["unitframe"]["units"]["player"]["colorOverride"] = "FORCE_OFF"
	E.db["unitframe"]["units"]["player"]["debuffs"]["xOffset"] = 0
	E.db["unitframe"]["units"]["player"]["debuffs"]["yOffset"] = -2
	E.db["unitframe"]["units"]["player"]["debuffs"]["anchorPoint"] = "BOTTOM"
	E.db["unitframe"]["units"]["player"]["debuffs"]["countFont"] = "Kimberley"
	E.db["unitframe"]["units"]["player"]["debuffs"]["countXOffset"] = 2
	E.db["unitframe"]["units"]["player"]["debuffs"]["countYOffset"] = -3
	E.db["unitframe"]["units"]["player"]["debuffs"]["height"] = 25
	E.db["unitframe"]["units"]["player"]["debuffs"]["keepSizeRatio"] = false
	E.db["unitframe"]["units"]["player"]["debuffs"]["priority"] = "Blacklist,blockNoDuration,Personal,nonPersonal"
	E.db["unitframe"]["units"]["player"]["debuffs"]["sizeOverride"] = 30
	E.db["unitframe"]["units"]["player"]["debuffs"]["numrows"] = 2
	E.db["unitframe"]["units"]["player"]["debuffs"]["perrow"] = 6
	E.db["unitframe"]["units"]["player"]["debuffs"]["enable"] = true
	E.db["unitframe"]["units"]["player"]["disableMouseoverGlow"] = true
	E.db["unitframe"]["units"]["player"]["fader"]["enable"] = true
	E.db["unitframe"]["units"]["player"]["fader"]["minAlpha"] = 0
	E.db["unitframe"]["units"]["player"]["healPrediction"]["absorbStyle"] = "REVERSED"
	E.db["unitframe"]["units"]["player"]["healPrediction"]["anchorPoint"] = "CENTER"
	E.db["unitframe"]["units"]["player"]["health"]["position"] = "RIGHT"
	E.db["unitframe"]["units"]["player"]["health"]["text_format"] = ""
	E.db["unitframe"]["units"]["player"]["health"]["xOffset"] = 0
	E.db["unitframe"]["units"]["player"]["name"]["text_format"] = ""
	E.db["unitframe"]["units"]["player"]["name"]["position"] = "LEFT"
	E.db["unitframe"]["units"]["player"]["name"]["xOffset"] = 3
	E.db["unitframe"]["units"]["player"]["portrait"]["camDistanceScale"] = 4.2
	E.db["unitframe"]["units"]["player"]["portrait"]["enable"] = true
	E.db["unitframe"]["units"]["player"]["portrait"]["fullOverlay"] = true
	E.db["unitframe"]["units"]["player"]["portrait"]["overlay"] = true
	E.db["unitframe"]["units"]["player"]["portrait"]["overlayAlpha"] = 0.3
	E.db["unitframe"]["units"]["player"]["power"]["EnergyManaRegen"] = true --tbc/classic only
	E.db["unitframe"]["units"]["player"]["power"]["attachTextTo"] = "Power"
	E.db["unitframe"]["units"]["player"]["power"]["height"] = 14
	E.db["unitframe"]["units"]["player"]["power"]["text_format"] = ""
	E.db["unitframe"]["units"]["player"]["power"]["width"] = "spaced"
	E.db["unitframe"]["units"]["player"]["power"]["xOffset"] = 0
	E.db["unitframe"]["units"]["player"]["power"]["autoHide"] = true
	--E.db["unitframe"]["units"]["player"]["power"]["detachFromFrame"] = true
	E.db["unitframe"]["units"]["player"]["power"]["detachFromFrame"] = false
	E.db["unitframe"]["units"]["player"]["power"]["detachedWidth"] = 295
	--E.db["unitframe"]["units"]["player"]["power"]["strataAndLevel"]["frameLevel"] = 128
	--E.db["unitframe"]["units"]["player"]["power"]["strataAndLevel"]["frameStrata"] = "HIGH"
	--E.db["unitframe"]["units"]["player"]["power"]["strataAndLevel"]["useCustomLevel"] = true
	E.db["unitframe"]["units"]["player"]["power"]["strataAndLevel"]["useCustomLevel"] = false
	E.db["unitframe"]["units"]["player"]["power"]["strataAndLevel"]["useCustomStrata"] = false
	E.db["unitframe"]["units"]["player"]["pvp"]["position"] = "CENTER"
	E.db["unitframe"]["units"]["player"]["pvp"]["text_format"] = ""
	E.db["unitframe"]["units"]["player"]["raidicon"]["attachTo"] = "CENTER"
	E.db["unitframe"]["units"]["player"]["raidicon"]["attachToObject"] = "Health"
	E.db["unitframe"]["units"]["player"]["raidicon"]["yOffset"] = 0
	E.db["unitframe"]["units"]["player"]["raidicon"]["enable"] = false
	E.db["unitframe"]["units"]["raid"]["buffIndicator"]["size"] = 12
	E.db["unitframe"]["units"]["raid"]["buffs"]["countFont"] = "Kimberley"
	E.db["unitframe"]["units"]["raid"]["buffs"]["countFontSize"] = 8
	E.db["unitframe"]["units"]["raid"]["buffs"]["countXOffset"] = 2
	E.db["unitframe"]["units"]["raid"]["buffs"]["countYOffset"] = -3
	E.db["unitframe"]["units"]["raid"]["buffs"]["durationPosition"] = "TOP"
	E.db["unitframe"]["units"]["raid"]["buffs"]["height"] = 15
	E.db["unitframe"]["units"]["raid"]["buffs"]["keepSizeRatio"] = false
	E.db["unitframe"]["units"]["raid"]["buffs"]["sizeOverride"] = 20
	E.db["unitframe"]["units"]["raid"]["colorOverride"] = "FORCE_OFF"
	E.db["unitframe"]["units"]["raid"]["debuffs"]["anchorPoint"] = "RIGHT"
	E.db["unitframe"]["units"]["raid"]["debuffs"]["attachTo"] = "HEALTH"
	E.db["unitframe"]["units"]["raid"]["debuffs"]["countFont"] = "Kimberley"
	E.db["unitframe"]["units"]["raid"]["debuffs"]["countFontSize"] = 8
	E.db["unitframe"]["units"]["raid"]["debuffs"]["countXOffset"] = 2
	E.db["unitframe"]["units"]["raid"]["debuffs"]["countYOffset"] = -3
	E.db["unitframe"]["units"]["raid"]["debuffs"]["desaturate"] = false
	E.db["unitframe"]["units"]["raid"]["debuffs"]["enable"] = true
	E.db["unitframe"]["units"]["raid"]["debuffs"]["growthY"] = "DOWN"
	E.db["unitframe"]["units"]["raid"]["debuffs"]["height"] = 15
	E.db["unitframe"]["units"]["raid"]["debuffs"]["keepSizeRatio"] = false
	E.db["unitframe"]["units"]["raid"]["debuffs"]["perrow"] = 5
	E.db["unitframe"]["units"]["raid"]["debuffs"]["priority"] = "Blacklist,Boss,CCDebuffs,Dispellable,Whitelist"
	E.db["unitframe"]["units"]["raid"]["debuffs"]["sizeOverride"] = 15
	E.db["unitframe"]["units"]["raid"]["debuffs"]["spacing"] = 0
	E.db["unitframe"]["units"]["raid"]["debuffs"]["xOffset"] = -75
	E.db["unitframe"]["units"]["raid"]["debuffs"]["yOffset"] = 5
	E.db["unitframe"]["units"]["raid"]["fader"]["minAlpha"] = 0.3
	E.db["unitframe"]["units"]["raid"]["fader"]["enable"] = true
	E.db["unitframe"]["units"]["raid"]["fader"]["range"] = true
	E.db["unitframe"]["units"]["raid"]["groupSpacing"] = 10
	E.db["unitframe"]["units"]["raid"]["healPrediction"]["absorbStyle"] = "REVERSED"
	E.db["unitframe"]["units"]["raid"]["healPrediction"]["enable"] = true
	E.db["unitframe"]["units"]["raid"]["health"]["text_format"] = ""
	E.db["unitframe"]["units"]["raid"]["height"] = 35
	E.db["unitframe"]["units"]["raid"]["horizontalSpacing"] = 0
	E.db["unitframe"]["units"]["raid"]["infoPanel"]["enable"] = true
	E.db["unitframe"]["units"]["raid"]["name"]["attachTextTo"] = "InfoPanel"
	E.db["unitframe"]["units"]["raid"]["name"]["position"] = "LEFT"
	E.db["unitframe"]["units"]["raid"]["name"]["text_format"] = ""
	E.db["unitframe"]["units"]["raid"]["portrait"]["desaturation"] = 0.7
	E.db["unitframe"]["units"]["raid"]["portrait"]["fullOverlay"] = true
	E.db["unitframe"]["units"]["raid"]["portrait"]["paused"] = true
	E.db["unitframe"]["units"]["raid"]["portrait"]["overlayAlpha"] = 0.6
	E.db["unitframe"]["units"]["raid"]["power"]["height"] = 8
	E.db["unitframe"]["units"]["raid"]["power"]["powerPrediction"] = true
	E.db["unitframe"]["units"]["raid"]["power"]["yOffset"] = 4
	E.db["unitframe"]["units"]["raid"]["power"]["text_format"] = ""
	if E.Retail then
		E.db["unitframe"]["units"]["raid"]["power"]["enable"] = false
	elseif E.Wrath or E.TBC or E.Classic then
		E.db["unitframe"]["units"]["raid"]["power"]["enable"] = true
	end
	E.db["unitframe"]["units"]["raid"]["raidicon"]["attachTo"] = "TOPRIGHT"
	E.db["unitframe"]["units"]["raid"]["raidicon"]["attachToObject"] = "Health"
	E.db["unitframe"]["units"]["raid"]["raidicon"]["size"] = 12
	E.db["unitframe"]["units"]["raid"]["raidicon"]["yOffset"] = 0
	E.db["unitframe"]["units"]["raid"]["rdebuffs"]["fontOutline"] = "THICKOUTLINE"
	E.db["unitframe"]["units"]["raid"]["rdebuffs"]["xOffset"] = -40
	E.db["unitframe"]["units"]["raid"]["rdebuffs"]["yOffset"] = 22
	E.db["unitframe"]["units"]["raid"]["rdebuffs"]["duration"]["yOffset"] = 3
	E.db["unitframe"]["units"]["raid"]["rdebuffs"]["font"] = "Kimberley"
	E.db["unitframe"]["units"]["raid"]["rdebuffs"]["fontOutline"] = "OUTLINE"
	E.db["unitframe"]["units"]["raid"]["rdebuffs"]["size"] = 20
	E.db["unitframe"]["units"]["raid"]["rdebuffs"]["stack"]["xOffset"] = 2
	E.db["unitframe"]["units"]["raid"]["rdebuffs"]["stack"]["yOffset"] = -3
	E.db["unitframe"]["units"]["raid"]["readycheckIcon"]["attachTo"] = "CENTER"
	E.db["unitframe"]["units"]["raid"]["resurrectIcon"]["attachToObject"] = "Health"
	E.db["unitframe"]["units"]["raid"]["resurrectIcon"]["size"] = 20
	E.db["unitframe"]["units"]["raid"]["roleIcon"]["size"] = 12
	E.db["unitframe"]["units"]["raid"]["roleIcon"]["xOffset"] = -1
	E.db["unitframe"]["units"]["raid"]["roleIcon"]["yOffset"] = -1
	E.db["unitframe"]["units"]["raid"]["raidRoleIcons"]["xOffset"] = 0
	E.db["unitframe"]["units"]["raid"]["raidRoleIcons"]["yOffset"] = 0
	E.db["unitframe"]["units"]["raid"]["summonIcon"]["attachToObject"] = "Health"
	E.db["unitframe"]["units"]["raid"]["summonIcon"]["size"] = 20
	E.db["unitframe"]["units"]["raid"]["threatStyle"] = "HEALTHBORDER"
	if E.Retail then
		E.db["unitframe"]["units"]["raid"]["visibility"] = "[@raid6,noexists][@raid21,exists] hide;show"
	elseif E.Wrath or E.TBC or E.Classic then
		E.db["unitframe"]["units"]["raid"]["visibility"] = "[@raid6,noexists][@raid26,exists] hide;show"
	end
	E.db["unitframe"]["units"]["raid"]["width"] = 150
	E.db["unitframe"]["units"]["raid40"]["buffIndicator"]["size"] = 12
	E.db["unitframe"]["units"]["raid40"]["buffs"]["sizeOverride"] = 17
	E.db["unitframe"]["units"]["raid40"]["colorOverride"] = "FORCE_OFF"
	E.db["unitframe"]["units"]["raid40"]["debuffs"]["anchorPoint"] = "RIGHT"
	E.db["unitframe"]["units"]["raid40"]["debuffs"]["attachTo"] = "HEALTH"
	E.db["unitframe"]["units"]["raid40"]["debuffs"]["countFont"] = "Kimberley"
	E.db["unitframe"]["units"]["raid40"]["debuffs"]["countFontOutline"] = "THICKOUTLINE"
	E.db["unitframe"]["units"]["raid40"]["debuffs"]["countFontSize"] = 10
	E.db["unitframe"]["units"]["raid40"]["debuffs"]["enable"] = true
	E.db["unitframe"]["units"]["raid40"]["debuffs"]["growthX"] = "LEFT"
	E.db["unitframe"]["units"]["raid40"]["debuffs"]["priority"] = "Blacklist,Boss,CCDebuffs,Dispellable,Whitelist"
	E.db["unitframe"]["units"]["raid40"]["debuffs"]["sizeOverride"] = 15
	E.db["unitframe"]["units"]["raid40"]["debuffs"]["spacing"] = 0
	E.db["unitframe"]["units"]["raid40"]["debuffs"]["xOffset"] = -45
	E.db["unitframe"]["units"]["raid40"]["debuffs"]["yOffset"] = 8
	E.db["unitframe"]["units"]["raid40"]["groupSpacing"] = 10
	E.db["unitframe"]["units"]["raid40"]["healPrediction"]["absorbStyle"] = "REVERSED"
	E.db["unitframe"]["units"]["raid40"]["healPrediction"]["enable"] = true
	E.db["unitframe"]["units"]["raid40"]["health"]["attachTextTo"] = "InfoPanel"
	E.db["unitframe"]["units"]["raid40"]["health"]["position"] = "RIGHT"
	E.db["unitframe"]["units"]["raid40"]["health"]["text_format"] = "[health:current:shortvalue]"
	E.db["unitframe"]["units"]["raid40"]["health"]["xOffset"] = 0
	E.db["unitframe"]["units"]["raid40"]["health"]["yOffset"] = 0
	E.db["unitframe"]["units"]["raid40"]["height"] = 35
	E.db["unitframe"]["units"]["raid40"]["horizontalSpacing"] = 0
	E.db["unitframe"]["units"]["raid40"]["infoPanel"]["enable"] = true
	E.db["unitframe"]["units"]["raid40"]["fader"]["minAlpha"] = 0.3
	E.db["unitframe"]["units"]["raid40"]["fader"]["enable"] = true
	E.db["unitframe"]["units"]["raid40"]["fader"]["range"] = true
	E.db["unitframe"]["units"]["raid40"]["name"]["attachTextTo"] = "InfoPanel"
	E.db["unitframe"]["units"]["raid40"]["name"]["position"] = "BOTTOMLEFT"
	E.db["unitframe"]["units"]["raid40"]["power"]["attachTextTo"] = "Power"
	E.db["unitframe"]["units"]["raid40"]["power"]["enable"] = true
	E.db["unitframe"]["units"]["raid40"]["power"]["height"] = 8
	E.db["unitframe"]["units"]["raid40"]["power"]["width"] = "inset"
	E.db["unitframe"]["units"]["raid40"]["power"]["xOffset"] = 0
	E.db["unitframe"]["units"]["raid40"]["power"]["yOffset"] = 0
	E.db["unitframe"]["units"]["raid40"]["raidRoleIcons"]["yOffset"] = 0
	E.db["unitframe"]["units"]["raid40"]["raidicon"]["attachToObject"] = "Health"
	E.db["unitframe"]["units"]["raid40"]["raidicon"]["size"] = 12
	E.db["unitframe"]["units"]["raid40"]["raidicon"]["yOffset"] = 0
	E.db["unitframe"]["units"]["raid40"]["rdebuffs"]["enable"] = true
	E.db["unitframe"]["units"]["raid40"]["rdebuffs"]["fontOutline"] = "OUTLINE"
	E.db["unitframe"]["units"]["raid40"]["rdebuffs"]["fontSize"] = 10
	E.db["unitframe"]["units"]["raid40"]["rdebuffs"]["size"] = 20
	E.db["unitframe"]["units"]["raid40"]["rdebuffs"]["xOffset"] = -25
	E.db["unitframe"]["units"]["raid40"]["rdebuffs"]["yOffset"] = 25
	E.db["unitframe"]["units"]["raid40"]["rdebuffs"]["duration"]["position"] = "TOP"
	E.db["unitframe"]["units"]["raid40"]["rdebuffs"]["duration"]["yOffset"] = 3
	E.db["unitframe"]["units"]["raid40"]["rdebuffs"]["font"] = "Kimberley"
	E.db["unitframe"]["units"]["raid40"]["rdebuffs"]["stack"]["yOffset"] = -2
	E.db["unitframe"]["units"]["raid40"]["rdebuffs"]["stack"]["xOffset"] = 2
	E.db["unitframe"]["units"]["raid40"]["orientation"] = "MIDDLE"
	E.db["unitframe"]["units"]["raid40"]["portrait"]["desaturation"] = 0.7
	E.db["unitframe"]["units"]["raid40"]["portrait"]["fullOverlay"] = true
	E.db["unitframe"]["units"]["raid40"]["portrait"]["overlayAlpha"] = 0.6
	E.db["unitframe"]["units"]["raid40"]["portrait"]["paused"] = true
	E.db["unitframe"]["units"]["raid40"]["readycheckIcon"]["attachTo"] = "CENTER"
	E.db["unitframe"]["units"]["raid40"]["resurrectIcon"]["attachToObject"] = "Health"
	E.db["unitframe"]["units"]["raid40"]["resurrectIcon"]["size"] = 15
	E.db["unitframe"]["units"]["raid40"]["roleIcon"]["enable"] = true
	E.db["unitframe"]["units"]["raid40"]["roleIcon"]["size"] = 12
	E.db["unitframe"]["units"]["raid40"]["roleIcon"]["xOffset"] = 0
	E.db["unitframe"]["units"]["raid40"]["roleIcon"]["yOffset"] = 9
	E.db["unitframe"]["units"]["raid40"]["summonIcon"]["attachToObject"] = "Health"
	E.db["unitframe"]["units"]["raid40"]["summonIcon"]["size"] = 15
	if E.Retail then
		E.db["unitframe"]["units"]["raid40"]["visibility"] = "[@raid21,noexists] hide;show"
	elseif E.Wrath or E.TBC or E.Classic then
		E.db["unitframe"]["units"]["raid40"]["visibility"] = "[@raid26,noexists] hide;show"
	end
	E.db["unitframe"]["units"]["raid40"]["width"] = 100
	if E.Retail then
		E.db["unitframe"]["units"]["raidpet"]["enable"] = false
	elseif E.Wrath or E.TBC or E.Classic then
		E.db["unitframe"]["units"]["raidpet"]["enable"] = true
	end
	E.db["unitframe"]["units"]["raidpet"]["healPrediction"]["absorbStyle"] = "REVERSED"
	E.db["unitframe"]["units"]["raidpet"]["rdebuffs"]["size"] = 20
	E.db["unitframe"]["units"]["raidpet"]["rdebuffs"]["yOffset"] = 5
	E.db["unitframe"]["units"]["target"]["CombatIcon"]["anchorPoint"] = "TOPLEFT"
	E.db["unitframe"]["units"]["target"]["CombatIcon"]["color"]["b"] = 1
	E.db["unitframe"]["units"]["target"]["CombatIcon"]["color"]["g"] = 1
	E.db["unitframe"]["units"]["target"]["CombatIcon"]["defaultColor"] = false
	E.db["unitframe"]["units"]["target"]["CombatIcon"]["xOffset"] = 8
	E.db["unitframe"]["units"]["target"]["CombatIcon"]["yOffset"] = -7
	E.db["unitframe"]["units"]["target"]["aurabar"]["attachTo"] = "FRAME"
	--E.db["unitframe"]["units"]["target"]["aurabar"]["attachTo"] = "DEBUFFS"
	E.db["unitframe"]["units"]["target"]["aurabar"]["spacing"] = 1
	E.db["unitframe"]["units"]["target"]["aurabar"]["yOffset"] = 1
	if E.Retail then
		E.db["unitframe"]["units"]["target"]["buffs"]["priority"] = "Blacklist,Personal,PlayerBuffs,Whitelist,blockNoDuration,nonPersonal,Dispellable"
	elseif E.Wrath or E.TBC or E.Classic then
		E.db["unitframe"]["units"]["target"]["buffs"]["priority"] = "Blacklist,Personal,PlayerBuffs,Whitelist,blockNoDuration,nonPersonal,Dispellable,BlizzardNameplate" --new for tbc/classic
	end
	E.db["unitframe"]["units"]["target"]["buffs"]["spacing"] = 2
	E.db["unitframe"]["units"]["target"]["buffs"]["anchorPoint"] = "TOP"
	--E.db["unitframe"]["units"]["target"]["buffs"]["anchorPoint"] = "BOTTOM"
	E.db["unitframe"]["units"]["target"]["buffs"]["attachTo"] = "FRAME"
	E.db["unitframe"]["units"]["target"]["buffs"]["countFont"] = "Kimberley"
	E.db["unitframe"]["units"]["target"]["buffs"]["growthX"] = "RIGHT"
	E.db["unitframe"]["units"]["target"]["buffs"]["height"] = 25
	E.db["unitframe"]["units"]["target"]["buffs"]["keepSizeRatio"] = false
	E.db["unitframe"]["units"]["target"]["buffs"]["numrows"] = 2
	--E.db["unitframe"]["units"]["target"]["buffs"]["perrow"] = 8
	E.db["unitframe"]["units"]["target"]["buffs"]["perrow"] = 6
	E.db["unitframe"]["units"]["target"]["buffs"]["sizeOverride"] = 30
	E.db["unitframe"]["units"]["target"]["buffs"]["sortDirection"] = "ASCENDING"
	--E.db["unitframe"]["units"]["target"]["buffs"]["enable"] = true
	E.db["unitframe"]["units"]["target"]["buffs"]["enable"] = false
	E.db["unitframe"]["units"]["target"]["buffs"]["countXOffset"] = 2
	E.db["unitframe"]["units"]["target"]["buffs"]["countYOffset"] = -3
	E.db["unitframe"]["units"]["target"]["buffs"]["durationPosition"] = "TOP"
	E.db["unitframe"]["units"]["target"]["buffs"]["maxDuration"] = 1200
	E.db["unitframe"]["units"]["target"]["buffs"]["xOffset"] = 0
	E.db["unitframe"]["units"]["target"]["buffs"]["yOffset"] = -2
	E.db["unitframe"]["units"]["target"]["castbar"]["customColor"]["useCustomBackdrop"] = true
	E.db["unitframe"]["units"]["target"]["castbar"]["customColor"]["colorBackdrop"]["b"] = 0
	E.db["unitframe"]["units"]["target"]["castbar"]["customColor"]["colorBackdrop"]["g"] = 0
	E.db["unitframe"]["units"]["target"]["castbar"]["customColor"]["colorBackdrop"]["r"] = 0
	E.db["unitframe"]["units"]["target"]["castbar"]["customColor"]["enable"] = true
	E.db["unitframe"]["units"]["target"]["castbar"]["customColor"]["transparent"] = false
	E.db["unitframe"]["units"]["target"]["castbar"]["customColor"]["useClassColor"] = true
	E.db["unitframe"]["units"]["target"]["castbar"]["reverse"] = true
	E.db["unitframe"]["units"]["target"]["castbar"]["height"] = 28
	E.db["unitframe"]["units"]["target"]["castbar"]["iconAttached"] = true
	E.db["unitframe"]["units"]["target"]["castbar"]["iconAttachedTo"] = "Castbar"
	E.db["unitframe"]["units"]["target"]["castbar"]["iconSize"] = 14
	E.db["unitframe"]["units"]["target"]["castbar"]["iconXOffset"] = 0
	E.db["unitframe"]["units"]["target"]["castbar"]["insideInfoPanel"] = false
	E.db["unitframe"]["units"]["target"]["castbar"]["overlayOnFrame"] = "Power"
	E.db["unitframe"]["units"]["target"]["castbar"]["strataAndLevel"]["frameLevel"] = 128
	E.db["unitframe"]["units"]["target"]["castbar"]["strataAndLevel"]["frameStrata"] = "MEDIUM"
	E.db["unitframe"]["units"]["target"]["castbar"]["strataAndLevel"]["useCustomStrata"] = true
	E.db["unitframe"]["units"]["target"]["castbar"]["textColor"]["b"] = 1
	E.db["unitframe"]["units"]["target"]["castbar"]["textColor"]["g"] = 1
	E.db["unitframe"]["units"]["target"]["castbar"]["textColor"]["r"] = 1
	E.db["unitframe"]["units"]["target"]["castbar"]["timeToHold"] = 1
	E.db["unitframe"]["units"]["target"]["castbar"]["xOffsetText"] = 2
	E.db["unitframe"]["units"]["target"]["castbar"]["yOffsetText"] = 1
	E.db["unitframe"]["units"]["target"]["colorOverride"] = "FORCE_OFF"
	E.db["unitframe"]["units"]["target"]["debuffs"]["attachTo"] = "FRAME"
	E.db["unitframe"]["units"]["target"]["debuffs"]["maxDuration"] = 0
	E.db["unitframe"]["units"]["target"]["debuffs"]["priority"] = "Blacklist,Personal,nonPersonal"
	E.db["unitframe"]["units"]["target"]["debuffs"]["countFont"] = "Kimberley"
	E.db["unitframe"]["units"]["target"]["debuffs"]["countFontOutline"] = "OUTLINE"
	E.db["unitframe"]["units"]["target"]["debuffs"]["countXOffset"] = 2
	E.db["unitframe"]["units"]["target"]["debuffs"]["countYOffset"] = -3
	E.db["unitframe"]["units"]["target"]["debuffs"]["durationPosition"] = "TOP"
	E.db["unitframe"]["units"]["target"]["debuffs"]["height"] = 25
	E.db["unitframe"]["units"]["target"]["debuffs"]["keepSizeRatio"] = false
	E.db["unitframe"]["units"]["target"]["debuffs"]["sizeOverride"] = 30
	E.db["unitframe"]["units"]["target"]["debuffs"]["anchorPoint"] = "BOTTOM"
	E.db["unitframe"]["units"]["target"]["debuffs"]["growthX"] = "RIGHT"
	E.db["unitframe"]["units"]["target"]["debuffs"]["spacing"] = 2
	E.db["unitframe"]["units"]["target"]["debuffs"]["numrows"] = 2
	E.db["unitframe"]["units"]["target"]["debuffs"]["perrow"] = 6
	E.db["unitframe"]["units"]["target"]["debuffs"]["xOffset"] = 0
	E.db["unitframe"]["units"]["target"]["debuffs"]["yOffset"] = -2
	E.db["unitframe"]["units"]["target"]["fader"]["enable"] = true
	E.db["unitframe"]["units"]["target"]["healPrediction"]["absorbStyle"] = "REVERSED"
	E.db["unitframe"]["units"]["target"]["healPrediction"]["anchorPoint"] = "CENTER"
	E.db["unitframe"]["units"]["target"]["health"]["text_format"] = ""
	E.db["unitframe"]["units"]["target"]["health"]["xOffset"] = 0
	E.db["unitframe"]["units"]["target"]["name"]["position"] = "LEFT"
	E.db["unitframe"]["units"]["target"]["name"]["text_format"] = ""
	E.db["unitframe"]["units"]["target"]["name"]["xOffset"] = 3
	E.db["unitframe"]["units"]["target"]["orientation"] = "RIGHT"
	E.db["unitframe"]["units"]["target"]["portrait"]["camDistanceScale"] = 4.2
	E.db["unitframe"]["units"]["target"]["portrait"]["enable"] = true
	E.db["unitframe"]["units"]["target"]["portrait"]["fullOverlay"] = true
	E.db["unitframe"]["units"]["target"]["portrait"]["overlay"] = true
	E.db["unitframe"]["units"]["target"]["portrait"]["overlayAlpha"] = 0.3
	E.db["unitframe"]["units"]["target"]["portrait"]["rotation"] = 291
	E.db["unitframe"]["units"]["target"]["portrait"]["xOffset"] = 0.1
	E.db["unitframe"]["units"]["target"]["power"]["attachTextTo"] = "Power"
	E.db["unitframe"]["units"]["target"]["power"]["height"] = 14
	E.db["unitframe"]["units"]["target"]["power"]["position"] = "RIGHT"
	E.db["unitframe"]["units"]["target"]["power"]["text_format"] = ""
	E.db["unitframe"]["units"]["target"]["power"]["width"] = "spaced"
	E.db["unitframe"]["units"]["target"]["power"]["xOffset"] = 0
	E.db["unitframe"]["units"]["target"]["raidicon"]["attachTo"] = "CENTER"
	E.db["unitframe"]["units"]["target"]["raidicon"]["attachToObject"] = "Health"
	E.db["unitframe"]["units"]["target"]["raidicon"]["yOffset"] = 0
	E.db["unitframe"]["units"]["target"]["raidicon"]["enable"] = false
	E.db["unitframe"]["units"]["targettarget"]["colorOverride"] = "FORCE_OFF"
	E.db["unitframe"]["units"]["targettarget"]["height"] = 54
	E.db["unitframe"]["units"]["targettarget"]["buffs"]["height"] = 25
	E.db["unitframe"]["units"]["targettarget"]["buffs"]["keepSizeRatio"] = false
	E.db["unitframe"]["units"]["targettarget"]["buffs"]["perrow"] = 6
	E.db["unitframe"]["units"]["targettarget"]["buffs"]["sizeOverride"] = 30
	E.db["unitframe"]["units"]["targettarget"]["debuffs"]["enable"] = false
	E.db["unitframe"]["units"]["targettarget"]["infoPanel"]["transparent"] = true
	E.db["unitframe"]["units"]["targettarget"]["name"]["text_format"] = ""
	E.db["unitframe"]["units"]["targettarget"]["power"]["attachTextTo"] = "Power"
	E.db["unitframe"]["units"]["targettarget"]["power"]["height"] = 14
	E.db["unitframe"]["units"]["targettarget"]["power"]["position"] = "RIGHT"
	E.db["unitframe"]["units"]["targettarget"]["power"]["width"] = "spaced"
	E.db["unitframe"]["units"]["targettarget"]["power"]["xOffset"] = -2
	E.db["unitframe"]["units"]["targettarget"]["power"]["yOffset"] = 1
	E.db["unitframe"]["units"]["targettarget"]["power"]["text_format"] = ""
	E.db["unitframe"]["units"]["targettarget"]["raidicon"]["attachTo"] = "CENTER"
	E.db["unitframe"]["units"]["targettarget"]["raidicon"]["attachToObject"] = "Health"
	E.db["unitframe"]["units"]["targettarget"]["raidicon"]["xOffset"] = 44
	E.db["unitframe"]["units"]["targettarget"]["raidicon"]["yOffset"] = 0
	E.db["unitframe"]["units"]["targettargettarget"]["debuffs"]["countFont"] = "Kimberley"

	E:StaggeredUpdateAll(nil, true)
	ElvUI_EltreumUI:Print(L["Healer Layout has been set."])
end
